#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=Beta
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_outfile=Vistumbler.exe
#AutoIt3Wrapper_Run_Tidy=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;--------------------------------------------------------
;AutoIt Version: 3.2.10.0 Beta
$Script_Author = 'Andrew Calcutt' 
$Script_Start_Date = '07/10/2007' 
$Script_Name = 'Vistumbler' 
$Script_Function = 'A netstumbler like program for vista. This Program uses "netsh wlan show networks mode=bssid" to get wireless information.' 
$version = 'v7.2 Beta - Pre-release 4' 
$last_modified = '12/2/2007' 
$title = $Script_Name & ' ' & $version & ' - By ' & $Script_Author & ' - ' & $last_modified
;Includes------------------------------------------------
#include <File.au3>
#include <Array.au3>
#include <Process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <GuiTreeView.au3>
#Include <String.au3>
#include "CommMG.au3"
;GUIRegisterMsg($WM_PAINT, '_RePaint')
; Set a COM Error handler--------------------------------
$oMyError = ObjEvent("AutoIt.Error", "MyErrFunc")
;Register-Netcomm-OCX------------------------------------
;_RunDOS('REGSVR32.EXE /s "' & @ScriptDir & '\NETComm.ocx"')
;Options-------------------------------------------------
Opt("TrayIconHide", 1);Hide icon in system tray
Opt("GUIOnEventMode", 1);Change to OnEvent mode
Opt("RunErrorsFatal", 0)
;Non Vista Warning---------------------------------------
If @OSVersion <> "WIN_VISTA"  Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")
;Declair-Variables---------------------------------------
Global $gdi_dll, $user32_dll
Global $hDC
Dim $sErr
Dim $CircleX, $CircleY, $CompassGraphic
Dim $SettingsDir = @ScriptDir & '\Settings\' 
Dim $LanguageDir = @ScriptDir & '\Languages\' 
Dim $SoundDir = @ScriptDir & '\Sounds\' 
Dim $SaveDir = @ScriptDir & '\Save\' 
Dim $settings = $SettingsDir & 'vistumbler_settings.ini' 
Dim $labelsini = $SettingsDir & 'mac_labels.ini' 
Dim $manufini = $SettingsDir & 'manufactures.ini' 
Dim $Latitude = 'N 0.0000000' 
Dim $Longitude = 'E 0.0000000' 
Dim $Latitude2 = 'N 0.0000000' 
Dim $Longitude2 = 'E 0.0000000' 
Dim $TurnOffGPS = 0
Dim $UseGPS = 0
Dim $Scan = 0
Dim $Close = 0
Dim $ResetRows = 0
Dim $ResetMacLabel = 0
Dim $ResetManLabel = 0
Dim $NewApFound = 0
Dim $ComError = 0
Dim $newdata = 0
Dim $o_old = 0
Dim $disconnected_time = -1
Dim $SortColumn = -1
Dim $GUIList
Dim $TempFileArray, $NetComm, $OpenArray, $headers, $MANUF, $LABEL, $SigHist
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates
Dim $addposition, $newlat, $newlon, $LatTest, $gps, $winpos
Dim $sort_timer
Dim $data_old
Dim $sizes, $sizes_old
Dim $GraphBack, $GraphGrid, $red, $black
Dim $base_add = 0, $data, $data_old, $Graph = 0, $Graph_old, $ResetSizes = 1, $Redraw = 1
Dim $LastSelected = -1

Dim $TreeviewAPs_left, $TreeviewAPs_width, $TreeviewAPs_top, $TreeviewAPs_height
Dim $ListviewAPs_left, $ListviewAPs_width, $ListviewAPs_top, $ListviewAPs_height
Dim $Graphic_left, $Graphic_width, $Graphic_top, $Graphic_height

Dim $FixTime, $FixTime2, $FixDate, $Quality, $NumberOfSatalites, $HorDilPitch, $Alt, $AltS, $Geo, $GeoS, $Status, $SpeedInKnots, $SpeedInMPH, $SpeedInKmH, $TrackAngle
Dim $Temp_FixTime, $Temp_FixTime2, $Temp_FixDate, $Temp_Lat, $Temp_Lon, $Temp_Lat2, $Temp_Lon2, $Temp_Quality, $Temp_NumberOfSatalites, $Temp_HorDilPitch, $Temp_Alt, $Temp_AltS, $Temp_Geo, $Temp_GeoS, $Temp_Status, $Temp_SpeedInKnots, $Temp_SpeedInMPH, $Temp_SpeedInKmH, $Temp_TrackAngle
Dim $GpsDetailsGUI, $GPGGA_Update, $GPGMC_Update, $GpsDetailsOpen = 0
Dim $GpsCurrentDataGUI, $GPGGA_Time, $GPGGA_Lat, $GPGGA_Lon, $GPGGA_Quality, $GPGGA_Satalites, $GPGGA_HorDilPitch, $GPGGA_Alt, $GPGGA_Geo, $GPGMC_Time, $GPGMC_Date, $GPGMC_Lat, $GPGMC_Lon, $GPGMC_Status, $GPGMC_SpeedKnots, $GPGMC_SpeedMPH, $GPGMC_SpeedKmh, $GPGMC_TrackAngle
;Define Arrays
Dim $Direction[19];Direction array for sorting by clicking on the header. Needs to be 1 greatet (or more) than the amount of columns
Dim $Direction2[3]
Dim $manu_mac[1], $manu_manu[1], $label_mac[1], $label_label[1];Define Arrays for "Labels by Mac" and "Manufacturer by Mac"

Dim $TmpArray_BSSID[1]
Dim $TmpArray_SSID[1]
Dim $TmpArray_Auth[1]
Dim $TmpArray_Encr[1]
Dim $TmpArray_Sig[1]
Dim $TmpArray_Chan[1]
Dim $TmpArray_Rad[1]
Dim $TmpArray_Lon[1]
Dim $TmpArray_Lat[1]
Dim $TmpArray_BtX[1]
Dim $TmpArray_OtX[1]
Dim $TmpArray_NetType[1]
Dim $TmpArray_Time[1]
Dim $TmpArray_FirstTime[1]
Dim $TmpArray_LastTime[1]
Dim $TmpArray_SigHist[1]
Dim $TmpArray_Manu[1]
Dim $TmpArray_Label[1]

Dim $DataArray_Line[1]
Dim $DataArray_Active[1]
Dim $DataArray_BSSID[1]
Dim $DataArray_SSID[1]
Dim $DataArray_Auth[1]
Dim $DataArray_Encr[1]
Dim $DataArray_Sig[1]
Dim $DataArray_Chan[1]
Dim $DataArray_Rad[1]
Dim $DataArray_Lon[1]
Dim $DataArray_Lat[1]
Dim $DataArray_BtX[1]
Dim $DataArray_OtX[1]
Dim $DataArray_NetType[1]
Dim $DataArray_FirstTime[1]
Dim $DataArray_LastTime[1]
Dim $DataArray_SigHist[1]
Dim $DataArray_Manu[1]
Dim $DataArray_Label[1]
Dim $DataArray_Row[1]
Dim $DataArray_TreeViewSubChannel[1]
Dim $DataArray_TreeViewSubSSID[1]
Dim $DataArray_TreeViewSubEncr[1]
Dim $DataArray_TreeViewSubAuth[1]
Dim $DataArray_TreeViewSubNetType[1]

Dim $TreeView_Channel_Name[1]
Dim $TreeView_SSID_Name[1]
Dim $TreeView_Encryption_Name[1]
Dim $TreeView_Authentication_Name[1]
Dim $TreeView_NetworkType_Name[1]
Dim $TreeView_Channel_Pos[1]
Dim $TreeView_SSID_Pos[1]
Dim $TreeView_Encryption_Pos[1]
Dim $TreeView_Authentication_Pos[1]
Dim $TreeView_NetworkType_Pos[1]

_SetTmpArraySizes()
_SetDataArraySizes()
_SetTreeArraySizes()

;Load-Settings-From-INI-File----------------------------
Dim $DefaultLanguage = IniRead($settings, 'Vistumbler', 'Language', 'English')
Dim $netsh = IniRead($settings, 'Vistumbler', 'Netsh_exe', 'netsh.exe')
Dim $ComPort = IniRead($settings, 'Vistumbler', 'ComPort', 8)
Dim $BAUD = IniRead($settings, 'Vistumbler', 'Baud', 4800)
Dim $GpsTimeout = IniRead($settings, 'Vistumbler', 'GpsTimeout', 30000)
Dim $saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1000)
Dim $SortTime = IniRead($settings, 'Vistumbler', 'AutoSortTime', 60)
Dim $SortBy = IniRead($settings, 'Vistumbler', 'SortCombo', 'Sort by SSID')
Dim $SortDirection = IniRead($settings, 'Vistumbler', 'AscDecDefault', 'Decending')
Dim $AutoSort = IniRead($settings, 'Vistumbler', 'AutoSort', 0)
Dim $SoundOnAP = IniRead($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
Dim $new_AP_sound = IniRead($settings, 'Vistumbler', 'NewAP_Sound', 'new_ap.wav')
Dim $error_sound = IniRead($settings, 'Vistumbler', 'Error_Sound', 'error.wav')
Dim $AddDirection = IniRead($settings, 'Vistumbler', 'NewApPosistion', 0)
Dim $BackgroundColor = IniRead($settings, 'Vistumbler', 'BackgroundColor', "0x99B4D1")
Dim $ControlBackgroundColor = IniRead($settings, 'Vistumbler', 'ControlBackgroundColor', "0xD7E4F2")
Dim $UseNetcomm = IniRead($settings, 'Vistumbler', 'UseNetcomm', 1)
Dim $column_Line = IniRead($settings, 'Columns', 'Column_Line', 0)
Dim $column_Active = IniRead($settings, 'Columns', 'Column_Active', 1)
Dim $column_SSID = IniRead($settings, 'Columns', 'Column_SSID', 2)
Dim $column_BSSID = IniRead($settings, 'Columns', 'Column_BSSID', 3)
Dim $column_MANUF = IniRead($settings, 'Columns', 'Column_Manufacturer', 4)
Dim $column_Signal = IniRead($settings, 'Columns', 'Column_Signal', 5)
Dim $column_Authentication = IniRead($settings, 'Columns', 'Column_Authentication', 6)
Dim $column_Encryption = IniRead($settings, 'Columns', 'Column_Encryption', 7)
Dim $column_RadioType = IniRead($settings, 'Columns', 'Column_RadioType', 8)
Dim $column_Channel = IniRead($settings, 'Columns', 'Column_Channel', 9)
Dim $column_Latitude = IniRead($settings, 'Columns', 'Column_Latitude', 10)
Dim $column_Longitude = IniRead($settings, 'Columns', 'Column_Longitude', 11)
Dim $column_BasicTransferRates = IniRead($settings, 'Columns', 'Column_BasicTransferRates', 12)
Dim $column_OtherTransferRates = IniRead($settings, 'Columns', 'Column_OtherTransferRates', 13)
Dim $column_FirstActive = IniRead($settings, 'Columns', 'Column_FirstActive', 14)
Dim $column_LastActive = IniRead($settings, 'Columns', 'Column_LastActive', 15)
Dim $column_NetworkType = IniRead($settings, 'Columns', 'Column_NetworkType', 16)
Dim $column_Label = IniRead($settings, 'Columns', 'Column_Label', 17)

Dim $column_Width_Active = IniRead($settings, 'Column_Width', 'Column_Active', 50)
Dim $column_Width_SSID = IniRead($settings, 'Column_Width', 'Column_SSID', 50)
Dim $column_Width_BSSID = IniRead($settings, 'Column_Width', 'Column_BSSID', 50)
Dim $column_Width_MANUF = IniRead($settings, 'Column_Width', 'Column_Manufacturer', 50)
Dim $column_Width_Signal = IniRead($settings, 'Column_Width', 'Column_Signal', 50)
Dim $column_Width_Authentication = IniRead($settings, 'Column_Width', 'Column_Authentication', 50)
Dim $column_Width_Encryption = IniRead($settings, 'Column_Width', 'Column_Encryption', 50)
Dim $column_Width_RadioType = IniRead($settings, 'Column_Width', 'Column_RadioType', 50)
Dim $column_Width_Channel = IniRead($settings, 'Column_Width', 'Column_Channel', 50)
Dim $column_Width_Latitude = IniRead($settings, 'Column_Width', 'Column_Latitude', 50)
Dim $column_Width_Longitude = IniRead($settings, 'Column_Width', 'Column_Longitude', 50)
Dim $column_Width_BasicTransferRates = IniRead($settings, 'Column_Width', 'Column_BasicTransferRates', 50)
Dim $column_Width_OtherTransferRates = IniRead($settings, 'Column_Width', 'Column_OtherTransferRates', 50)
Dim $column_Width_FirstActive = IniRead($settings, 'Column_Width', 'Column_FirstActive', 50)
Dim $column_Width_LastActive = IniRead($settings, 'Column_Width', 'Column_LastActive', 50)
Dim $column_Width_NetworkType = IniRead($settings, 'Column_Width', 'Column_NetworkType', 50)
Dim $column_Width_Label = IniRead($settings, 'Column_Width', 'Column_Label', 50)

Dim $Column_Names_Line = IniRead($settings, 'Column_Names', 'Column_Line', '#')
Dim $Column_Names_Active = IniRead($settings, 'Column_Names', 'Column_Active', 'Active')
Dim $Column_Names_SSID = IniRead($settings, 'Column_Names', 'Column_SSID', 'SSID')
Dim $Column_Names_BSSID = IniRead($settings, 'Column_Names', 'Column_BSSID', 'Mac Address')
Dim $Column_Names_MANUF = IniRead($settings, 'Column_Names', 'Column_Manufacturer', 'Manufacturer')
Dim $Column_Names_Signal = IniRead($settings, 'Column_Names', 'Column_Signal', 'Signal')
Dim $Column_Names_Authentication = IniRead($settings, 'Column_Names', 'Column_Authentication', 'Authentication')
Dim $Column_Names_Encryption = IniRead($settings, 'Column_Names', 'Column_Encryption', 'Encryption')
Dim $Column_Names_RadioType = IniRead($settings, 'Column_Names', 'Column_RadioType', 'Radio Type')
Dim $Column_Names_Channel = IniRead($settings, 'Column_Names', 'Column_Channel', 'Channel')
Dim $Column_Names_Latitude = IniRead($settings, 'Column_Names', 'Column_Latitude', 'Latitude')
Dim $Column_Names_Longitude = IniRead($settings, 'Column_Names', 'Column_Longitude', 'Longitude')
Dim $Column_Names_BasicTransferRates = IniRead($settings, 'Column_Names', 'Column_BasicTransferRates', 'Basic Transfer Rates')
Dim $Column_Names_OtherTransferRates = IniRead($settings, 'Column_Names', 'Column_OtherTransferRates', 'Other Transfer Rates')
Dim $Column_Names_FirstActive = IniRead($settings, 'Column_Names', 'Column_FirstActive', 'First Active')
Dim $Column_Names_LastActive = IniRead($settings, 'Column_Names', 'Column_LastActive', 'Last Active')
Dim $Column_Names_NetworkType = IniRead($settings, 'Column_Names', 'Column_NetworkType', 'Network Type')
Dim $Column_Names_Label = IniRead($settings, 'Column_Names', 'Column_Label', 'Label')

Dim $SearchWord_SSID = IniRead($settings, 'SearchWords', 'SSID', 'SSID')
Dim $SearchWord_BSSID = IniRead($settings, 'SearchWords', 'BSSID', 'BSSID')
Dim $SearchWord_NetworkType = IniRead($settings, 'SearchWords', 'NetworkType', 'Network type')
Dim $SearchWord_Authentication = IniRead($settings, 'SearchWords', 'Authentication', 'Authentication')
Dim $SearchWord_Encryption = IniRead($settings, 'SearchWords', 'Encryption', 'Encryption')
Dim $SearchWord_Signal = IniRead($settings, 'SearchWords', 'Signal', 'Signal')
Dim $SearchWord_RadioType = IniRead($settings, 'SearchWords', 'RadioType', 'Radio Type')
Dim $SearchWord_Channel = IniRead($settings, 'SearchWords', 'Channel', 'Channel')
Dim $SearchWord_BasicRates = IniRead($settings, 'SearchWords', 'BasicRates', 'Basic Rates')
Dim $SearchWord_OtherRates = IniRead($settings, 'SearchWords', 'OtherRates', 'Other Rates')
Dim $SearchWord_None = IniRead($settings, 'SearchWords', 'None', 'None')
Dim $SearchWord_Open = IniRead($settings, 'SearchWords', 'Open', 'Open')

Dim $Text_Ok = IniRead($settings, 'GuiText', 'Ok', '&Ok')
Dim $Text_Cancel = IniRead($settings, 'GuiText', 'Cancel', 'C&ancel')

Dim $Text_File = IniRead($settings, 'GuiText', 'File', '&File')
Dim $Text_SaveAsTXT = IniRead($settings, 'GuiText', 'SaveAsTXT', 'Save As &TXT')
Dim $Text_ImportFromTXT = IniRead($settings, 'GuiText', 'ImportFromTXT', 'Import From &TXT')
Dim $Text_Exit = IniRead($settings, 'GuiText', 'Exit', 'E&xit')

Dim $Text_Edit = IniRead($settings, 'GuiText', 'Edit', 'E&dit')
Dim $Text_Cut = IniRead($settings, 'GuiText', 'Cut', 'Cut')
Dim $Text_Copy = IniRead($settings, 'GuiText', 'Copy', 'Copy')
Dim $Text_Paste = IniRead($settings, 'GuiText', 'Paste', 'Paste')
Dim $Text_Delete = IniRead($settings, 'GuiText', 'Delete', 'Delete')
Dim $Text_Select = IniRead($settings, 'GuiText', 'Select', 'Select')
Dim $Text_SelectAll = IniRead($settings, 'GuiText', 'SelectAll', 'Select All')

Dim $Text_Options = IniRead($settings, 'GuiText', 'Options', '&Options')
Dim $Text_AutoSort = IniRead($settings, 'GuiText', 'AutoSort', 'AutoSort')
Dim $Text_SortTree = IniRead($settings, 'GuiText', 'SortTree', 'Sort Tree  - (slow on big lists)')
Dim $Text_PlaySound = IniRead($settings, 'GuiText', 'PlaySound', 'Play sound on new AP')
Dim $Text_AddAPsToTop = IniRead($settings, 'GuiText', 'AddAPsToTop', 'Add new APs to top')

Dim $Text_Extra = IniRead($settings, 'GuiText', 'Extra', 'Ex&tra')
Dim $Text_ScanAPs = IniRead($settings, 'GuiText', 'ScanAPs', '&Scan APs')
Dim $Text_StopScanAps = IniRead($settings, 'GuiText', 'StopScanAps', '&Stop')
Dim $Text_UseGPS = IniRead($settings, 'GuiText', 'UseGPS', 'Use &GPS')
Dim $Text_StopGPS = IniRead($settings, 'GuiText', 'StopGPS', 'Stop &GPS')

Dim $Text_Settings = IniRead($settings, 'GuiText', 'Settings', 'S&ettings')
Dim $Text_GpsSettings = IniRead($settings, 'GuiText', 'GpsSettings', 'G&PS Settings')
Dim $Text_SetLanguage = IniRead($settings, 'GuiText', 'SetLanguage', 'Set &Language')
Dim $Text_SetSearchWords = IniRead($settings, 'GuiText', 'SetSearchWords', 'Set Search &Words')
Dim $Text_SetMacLabel = IniRead($settings, 'GuiText', 'SetMacLabel', 'Set Labels by Mac')
Dim $Text_SetMacManu = IniRead($settings, 'GuiText', 'SetMacManu', 'Set Manufactures by Mac')

Dim $Text_Export = IniRead($settings, 'GuiText', 'Export', 'Ex&port')
Dim $Text_ExportToKML = IniRead($settings, 'GuiText', 'ExportToKML', 'ExportToKML')
Dim $Text_ExportToTXT = IniRead($settings, 'GuiText', 'ExportToTXT', 'ExportToTXT')
Dim $Text_PhilsPHPgraph = IniRead($settings, 'GuiText', 'PhilsPHPgraph', 'View graph (Phils PHP version)')
Dim $Text_PhilsMultiPHPgraph = IniRead($settings, 'GuiText', 'PhilsMultiPHPgraph', 'Graph all APs (Phils PHP version)')

Dim $Text_RefreshLoopTime = IniRead($settings, 'GuiText', 'RefreshLoopTime', 'Refresh loop time(ms):')
Dim $Text_ActualLoopTime = IniRead($settings, 'GuiText', 'ActualLoopTime', 'Actual loop time:')
Dim $Text_Longitude = IniRead($settings, 'GuiText', 'Longitude', 'Longitude:')
Dim $Text_Latitude = IniRead($settings, 'GuiText', 'Latitude', 'Latitude:')
Dim $Text_ActiveAPs = IniRead($settings, 'GuiText', 'ActiveAPs', 'Active APs:')
Dim $Text_Graph1 = IniRead($settings, 'GuiText', 'Graph1', 'Graph1')
Dim $Text_Graph2 = IniRead($settings, 'GuiText', 'Graph2', 'Graph2')
Dim $Text_NoGraph = IniRead($settings, 'GuiText', 'NoGraph', 'No Graph')
Dim $Text_Active = IniRead($settings, 'GuiText', 'Active', 'Active')
Dim $Text_Dead = IniRead($settings, 'GuiText', 'Dead', 'Dead')

Dim $Text_AddNewLabel = IniRead($settings, 'GuiText', 'AddNewLabel', 'Add New Label To List')
Dim $Text_RemoveLabel = IniRead($settings, 'GuiText', 'RemoveLabel', 'Remove Selected Label From List')
Dim $Text_EditLabel = IniRead($settings, 'GuiText', 'EditLabel', 'Edit Selected Label')
Dim $Text_AddNewMan = IniRead($settings, 'GuiText', 'AddNewMan', 'Add New Manufacturer To List')
Dim $Text_RemoveMan = IniRead($settings, 'GuiText', 'RemoveMan', 'Remove Selected Manufacturer From List')
Dim $Text_EditMan = IniRead($settings, 'GuiText', 'EditMan', 'Edit Selected Manufacturer')
Dim $Text_NewMac = IniRead($settings, 'GuiText', 'NewMac', 'New Mac Address:')
Dim $Text_NewMan = IniRead($settings, 'GuiText', 'NewMan', 'New Manufacturer:')
Dim $Text_NewLabel = IniRead($settings, 'GuiText', 'NewLabel', 'New Label:')
Dim $Text_Save = IniRead($settings, 'GuiText', 'Save', 'Save?')
Dim $Text_SaveQuestion = IniRead($settings, 'GuiText', 'SaveQuestion', 'Data has changed. Would you like to save?')

Dim $Text_GpsDetails = IniRead($settings, 'GuiText', 'GpsDetails', 'GPS Details')
Dim $Text_Quality = IniRead($settings, 'GuiText', 'Quality', 'Quality')
Dim $Text_Time = IniRead($settings, 'GuiText', 'Time', 'Time')
Dim $Text_NumberOfSatalites = IniRead($settings, 'GuiText', 'NumberOfSatalites', 'Number of Satalites')
Dim $Text_HorizontalDilutionPosition = IniRead($settings, 'GuiText', 'HorizontalDilutionPosition', 'Horizontal Dilution')
Dim $Text_Altitude = IniRead($settings, 'GuiText', 'Altitude', 'Altitude')
Dim $Text_HeightOfGeoid = IniRead($settings, 'GuiText', 'HeightOfGeoid', 'Height of Geoid')
Dim $Text_Status = IniRead($settings, 'GuiText', 'Status', 'Status')
Dim $Text_Date = IniRead($settings, 'GuiText', 'Date', 'Date')
Dim $Text_SpeedInKnots = IniRead($settings, 'GuiText', 'SpeedInKnots', 'Speed(knots)')
Dim $Text_SpeedInMPH = IniRead($settings, 'GuiText', 'SpeedInMPH', 'Speed(MPH)')
Dim $Text_SpeedInKmh = IniRead($settings, 'GuiText', 'SpeedInKmh', 'Speed(km/h)')
Dim $Text_TrackAngle = IniRead($settings, 'GuiText', 'TrackAngle', 'Track Angle')
Dim $Text_Close = IniRead($settings, 'GuiText', 'Close', 'Close')

;Create-Array-Of-Manufactures----------------------------
_ReadIniSectionToArrays($manufini, $manu_mac, $manu_manu, "MANUFACURERS")

;Create-Array-Of-Labels----------------------------
_ReadIniSectionToArrays($labelsini, $label_mac, $label_label, "LABELS")

;Set-Up-Column-Headers-Based-On-INI-File-----------------
$var = IniReadSection($settings, "Columns")
If @error Then
	$headers = '#|Active|SSID|Mac Address|Manufacturer|Signal|Authentication|Encryption|Radio Type|Channel|Latitude|Longitude|Basic Transfer Rates|Other Transfer Rates|First Active|Last Updated|Network Type|Label' 
Else
	For $a = 0 To ($var[0][0] - 1)
		For $b = 1 To $var[0][0]
			If $a = $var[$b][1] Then $headers &= IniRead($settings, 'Column_Names', $var[$b][0], '') & '|' 
		Next
	Next
EndIf

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GUI
;-------------------------------------------------------------------------------------------------------------------------------
$Vistumbler = GUICreate($title, 908, 692, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
GUISetBkColor($BackgroundColor)

$File = GUICtrlCreateMenu($Text_File)
$SaveAsTXT = GUICtrlCreateMenuItem($Text_SaveAsTXT, $File)
$ImportFromTXT = GUICtrlCreateMenuItem($Text_ImportFromTXT, $File)
$ExitVistumbler = GUICtrlCreateMenuItem($Text_Exit, $File)
;$Edit = GUICtrlCreateMenu("&Edit")
;$Cut = GUICtrlCreateMenuitem("Cut", $Edit)
;$Copy = GUICtrlCreateMenuitem("Copy", $Edit)
;$Delete = GUICtrlCreateMenuItem("Delete", $Edit)
;$SelectAll = GUICtrlCreateMenuItem("Select All", $Edit)
$Options = GUICtrlCreateMenu($Text_Options)
$ScanWifiGUI = GUICtrlCreateMenuItem($Text_ScanAPs, $Options)
$AutoSortGUI = GUICtrlCreateMenuItem($Text_AutoSort, $Options)
If $AutoSort = 1 Then GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
$SortTree = GUICtrlCreateMenuItem($Text_SortTree, $Options)
$PlaySoundOnNewAP = GUICtrlCreateMenuItem($Text_PlaySound, $Options)
If $SoundOnAP = 1 Then GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
$AddNewAPsToTop = GUICtrlCreateMenuItem($Text_AddAPsToTop, $Options)
If $AddDirection = 0 Then GUICtrlSetState(-1, $GUI_CHECKED)
;$ShowGridLines = GUICtrlCreateMenuitem("Show Grid Lines", $Options)
;If $ShowGrid = 1 Then GUICtrlSetState($ShowGridLines, $GUI_CHECKED)

$settingsGUI = GUICtrlCreateMenu($Text_Settings)
$UseGpsGUI = GUICtrlCreateMenuItem($Text_GpsSettings, $settingsGUI)
$SetLanguage = GUICtrlCreateMenuItem($Text_SetLanguage, $settingsGUI)
$SetSearchWords = GUICtrlCreateMenuItem($Text_SetSearchWords, $settingsGUI)
$SetMacLabel = GUICtrlCreateMenuItem($Text_SetMacLabel, $settingsGUI)
$SetMacManu = GUICtrlCreateMenuItem($Text_SetMacManu, $settingsGUI)

$Export = GUICtrlCreateMenu($Text_Export)
$ExportToKML = GUICtrlCreateMenuItem($Text_ExportToKML, $Export)
$ExportToTXT2 = GUICtrlCreateMenuItem($Text_ExportToTXT, $Export)

$Extra = GUICtrlCreateMenu($Text_Extra)
$GpsDetails = GUICtrlCreateMenuItem($Text_GpsDetails, $Extra)
$ViewInPhilsPHP = GUICtrlCreateMenuItem($Text_PhilsPHPgraph, $Extra)

$GraphicGUI = GUICreate("", 895.72, 386.19, 10, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($ControlBackgroundColor)

$DataChild = GUICreate("", 895, 595, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($BackgroundColor)
$ListviewAPs = GUICtrlCreateListView($headers, 260, 5, 725, 585, $LVS_REPORT + $LVS_SINGLESEL, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$TreeviewAPs = GUICtrlCreateTreeView(5, 5, 150, 585)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
GUISetState()

$ControlChild = GUICreate("", 908, 65, 0, 0, $WS_CHILD, $WS_EX_CONTROLPARENT, $Vistumbler) ; Create Child window for controls
GUISetBkColor($BackgroundColor)
$ScanButton = GUICtrlCreateButton($Text_ScanAPs, 10, 8, 60, 20, 0)
$GpsButton = GUICtrlCreateButton($Text_UseGPS, 75, 8, 60, 20, 0)
$GraphButton1 = GUICtrlCreateButton($Text_Graph1, 10, 35, 60, 20, 0)
$GraphButton2 = GUICtrlCreateButton($Text_Graph2, 75, 35, 60, 20, 0)

GUICtrlCreateLabel($Text_ActiveAPs, 140, 10, 60, 17)
$ActiveAPs = GUICtrlCreateInput('', 205, 7, 90, 21)
GUICtrlCreateLabel($Text_Latitude, 300, 10, 45, 17)
$GuiLat = GUICtrlCreateInput($Latitude, 350, 7, 80, 21)
GUICtrlCreateLabel($Text_Longitude, 435, 10, 50, 17)
$GuiLon = GUICtrlCreateInput($Longitude, 490, 7, 80, 21)

GUICtrlCreateLabel($Text_RefreshLoopTime, 575, 10, 105, 17)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 685, 7, 55, 21)
GUICtrlCreateLabel($Text_ActualLoopTime, 745, 10, 80, 17)
$timediff = GUICtrlCreateInput('', 830, 7, 70, 21)


$msgdisplay = GUICtrlCreateLabel('', 140, 38, 665, 17)

GUISetState(@SW_SHOW)

GUISwitch($Vistumbler)
_SetControlSizes()
GUISetState(@SW_SHOW)

;Button-Events-------------------------------------------
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseToggle')
GUISetOnEvent($GUI_EVENT_RESIZED, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_RESTORE, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_MAXIMIZE, '_ResetSizes')
GUICtrlSetOnEvent($ExitVistumbler, '_CloseToggle')
GUICtrlSetOnEvent($ScanButton, 'ScanToggle')
GUICtrlSetOnEvent($ScanWifiGUI, 'ScanToggle')
GUICtrlSetOnEvent($UseGpsGUI, '_GPSOptions')
GUICtrlSetOnEvent($GpsButton, '_GpsToggle')
GUICtrlSetOnEvent($AutoSortGUI, '_SortOptions')
GUICtrlSetOnEvent($SaveAsTXT, '_ExportData')
GUICtrlSetOnEvent($ImportFromTXT, 'LoadList')
GUICtrlSetOnEvent($ExportToKML, 'SaveToKML')
GUICtrlSetOnEvent($ExportToTXT2, '_ExportData')
GUICtrlSetOnEvent($PlaySoundOnNewAP, '_SoundToggle')
GUICtrlSetOnEvent($AddNewAPsToTop, '_AddApPosToggle')
GUICtrlSetOnEvent($ListviewAPs, '_SortColumnToggle')
GUICtrlSetOnEvent($SetSearchWords, '_SearchWordsGUI')
GUICtrlSetOnEvent($SortTree, '_SortTree')
GUICtrlSetOnEvent($GraphButton1, '_GraphToggle')
GUICtrlSetOnEvent($GraphButton2, '_GraphToggle2')
GUICtrlSetOnEvent($GpsDetails, '_OpenGpsDetailsGUI')
GUICtrlSetOnEvent($ViewInPhilsPHP, '_ViewInPhilsPHP')
GUICtrlSetOnEvent($SetLanguage, '_SelectLanguage')
GUICtrlSetOnEvent($SetMacLabel, '_MacLabelGUI')
GUICtrlSetOnEvent($SetMacManu, '_MacManuGUI')

;Set column widths - All variables have ' - 0' after them to make this work. it would not set column widths without the ' - 0'
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Active - 0, $column_Width_Active - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_SSID - 0, $column_Width_SSID - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_BSSID - 0, $column_Width_BSSID - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_MANUF - 0, $column_Width_MANUF - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Signal - 0, $column_Width_Signal - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Authentication - 0, $column_Width_Authentication - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Encryption - 0, $column_Width_Encryption - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_RadioType - 0, $column_Width_RadioType - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Channel - 0, $column_Width_Channel - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Latitude - 0, $column_Width_Latitude - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Longitude - 0, $column_Width_Longitude - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_BasicTransferRates - 0, $column_Width_BasicTransferRates - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_OtherTransferRates - 0, $column_Width_OtherTransferRates - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_FirstActive - 0, $column_Width_FirstActive - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_LastActive - 0, $column_Width_LastActive - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_NetworkType - 0, $column_Width_NetworkType - 0)
_GUICtrlListView_SetColumnWidth ($ListviewAPs, $column_Label - 0, $column_Width_Label - 0)

Dim $Authentication_tree = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Authentication)
Dim $channel_tree = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Channel)
Dim $Encryption_tree = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Encryption)
Dim $NetworkType_tree = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_NetworkType)
Dim $SSID_tree = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_SSID)

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       PROGRAM RUNNING LOOP
;-------------------------------------------------------------------------------------------------------------------------------

$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	
	If $Scan = 1 Or $UseGPS = 1 Then
		If $UseGPS = 1 Then ; If 'Use GPS' is checked then scan gps and display information
			$GetGpsSuccess = _GetGPS();Scan for GPS if GPS enabled
			If $GetGpsSuccess = 1 Then
				GUICtrlSetData($GuiLat, $Latitude);Set GPS Latitude in GUI
				GUICtrlSetData($GuiLon, $Longitude);Set GPS Longitude in GUI
			Else
				If $UseNetcomm = 1 Then GUICtrlSetData($msgdisplay, 'GPS Error. Buffer Empty for more than 10 seconds. GPS was probrably disconnected. GPS has been stopped')
				If $UseNetcomm = 0 Then GUICtrlSetData($msgdisplay, 'GPS Error. GPS has been stopped')
				Sleep(1500)
			EndIf
		Else
			GUICtrlSetData($msgdisplay, '') ;Clear Message
		EndIf
		If $Scan = 1 Then _ScanAccessPoints();Scan for Access Points if scanning enabled
		
		_UpdateList();Update Listview with new data
		
		If $AutoSort = 1 And TimerDiff($sort_timer) >= ($SortTime * 1000) Then _Sort($SortBy)
		_GraphApSignal()
		$time = TimerDiff($begin)
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		_UpdateList(); Mark access points as dead
		_GraphApSignal()
		$time = TimerDiff($begin)
		Sleep(100)
	EndIf
	
	
	If $Close = 1 Then _ExitVistumbler() ;If the close flag has been set, exit visumbler
	If $SortColumn <> -1 Then _HeaderSort($SortColumn)
	
	If $ResetSizes = 1 Then
		_SetControlSizes()
		$ResetSizes = 0
		$Redraw = 1
	EndIf
	
	If _WinMoved() = 1 Then $Redraw = 1
	
	GUICtrlSetData($timediff, Round($time) & ' / ' & Round(TimerDiff($begin))); & 'mS'); Set 'Actual Loop Time' in GUI
WEnd
Exit

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       WIFI SCAN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ScanAccessPoints()
	$basetimestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
	$timestamp_timer = TimerInit()
	$netsh_output = Run(@ComSpec & " /c netsh wlan show networks mode=bssid", '', @SW_HIDE, 2)
	$netsh_line = ''
	While 1
		$netsh_line &= StdoutRead($netsh_output)
		If @error Then ExitLoop
	WEnd
	$TempFileArray = StringSplit($netsh_line, @CR)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array
		If StringInStr($TempFileArray[$loop], $SearchWord_SSID) Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $MANUF ;Clear Variables
			While BitAND(StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID), Not StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID)) <> 1
				;StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 1 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) = 1
				$temp = StringSplit(StringStripWS($TempFileArray[$loop], 3), ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], $SearchWord_SSID) = 1 And StringInStr($temp[1], $SearchWord_BSSID) <> 1 Then
						$SSID = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_NetworkType) Then
						$NetworkType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Authentication) Then
						$Authentication = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Encryption) Then
						$Encryption = StringStripWS($temp[2], 3)
					EndIf
					If StringInStr($temp[1], $SearchWord_BSSID) Then ;
						While 1
							$temp = StringSplit($TempFileArray[$loop], ":")
							If IsArray($temp) Then ; Strip Data from line
								If StringInStr($temp[1], $SearchWord_BSSID) Then
									$BSSID = StringStripWS(StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7]), 3)
								ElseIf StringInStr($temp[1], $SearchWord_Signal) Then
									$Signal = StringStripWS(StringFormat("%2d", StringTrimRight(StringStripWS($temp[2], 3), 1)) & '%', 3)
								ElseIf StringInStr($temp[1], $SearchWord_RadioType) Then
									$RadioType = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_Channel) Then
									$Channel = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_BasicRates) Then
									$BasicTransferRates = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_OtherRates) Then
									$OtherTransferRates = StringStripWS($temp[2], 3)
								EndIf
							EndIf
							If StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 0 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) <> 0 Or $TempFileArray[$loop + 1] = '' Or ($loop + 1) >= $TempFileArray[0] Then ExitLoop
							$loop += 1
						WEnd
						If $BSSID <> '' Then ; If Mac Address($BSSID) was not empty then see if it is in the list box. If it is, update it. If not, add it                                                                                                                                                     ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
							$timestamp = $basetimestamp & ' ' & Round((TimerDiff($timestamp_timer)))
							;Add Data into the Tmp Arrays for use in _UpdateList()
							_ArrayInsert($TmpArray_BSSID, 1, $BSSID)
							_ArrayInsert($TmpArray_SSID, 1, $SSID)
							_ArrayInsert($TmpArray_Auth, 1, $Authentication)
							_ArrayInsert($TmpArray_Encr, 1, $Encryption)
							_ArrayInsert($TmpArray_Sig, 1, $Signal)
							_ArrayInsert($TmpArray_Chan, 1, $Channel)
							_ArrayInsert($TmpArray_Rad, 1, $RadioType)
							_ArrayInsert($TmpArray_BtX, 1, $BasicTransferRates)
							_ArrayInsert($TmpArray_OtX, 1, $OtherTransferRates)
							_ArrayInsert($TmpArray_NetType, 1, $NetworkType)
							_ArrayInsert($TmpArray_Time, 1, $timestamp)
							Dim $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = ''
						EndIf
					EndIf
				EndIf
				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
		EndIf
	Next
	_SetTmpArraySizes()
EndFunc   ;==>_ScanAccessPoints

Func _UpdateList()
	$TmpArray_BSSID[0] = UBound($TmpArray_BSSID) - 1
	$Active = $TmpArray_BSSID[0]
	$StartArraySize = $DataArray_BSSID[0]
	For $listval = 1 To $DataArray_BSSID[0]
		$addposition = -1
		For $tmplistval = 1 To $TmpArray_BSSID[0]
			$newdata = 1
			If $DataArray_BSSID[$listval] = $TmpArray_BSSID[$tmplistval] Then
				If $DataArray_SSID[$listval] = $TmpArray_SSID[$tmplistval] And _
						$DataArray_Auth[$listval] = $TmpArray_Auth[$tmplistval] And _
						$DataArray_Encr[$listval] = $TmpArray_Encr[$tmplistval] And _
						$DataArray_Chan[$listval] = $TmpArray_Chan[$tmplistval] And _
						$DataArray_NetType[$listval] = $TmpArray_NetType[$tmplistval] Then
					
					Dim $MANUF = '', $LABEL = ''
					$addposition = $DataArray_Row[$listval]
					
					$TrimmedSignal = StringTrimRight($TmpArray_Sig[$tmplistval], 1)
					$CurrentSignal = $DataArray_SigHist[$listval] & "-" & $TrimmedSignal
					If StringLen($CurrentSignal) > 5000 Then
						$CurrentSignal = StringTrimLeft($CurrentSignal, StringLen($CurrentSignal) - 5000);Strip to Signal History 5000 chars
						$CurrentSignal = StringTrimLeft($CurrentSignal, StringInStr($CurrentSignal, '-') + 1);Strip to Last full result
					EndIf
					
					If $TrimmedSignal = $DataArray_Sig[$addposition] Then $Signal = ''
					
					If StringTrimLeft($Latitude, 2) = '0.0000000'  Or $Latitude = '' Or StringTrimLeft($Longitude, 2) = '0.0000000'  Or $Longitude = '' Or StringTrimLeft($DataArray_Lat[$addposition], 2) <> '0.0000000'  Then
						Dim $newlat = '', $newlon = ''
					Else
						Dim $newlat = $Latitude, $newlon = $Longitude
					EndIf
					
					$StripedBSSID = StringReplace($DataArray_BSSID[$listval], ':', '')
					If $DataArray_Manu[$listval] = '' Or $ResetMacLabel = 1 Then $MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
					If $DataArray_Label[$listval] = '' Or $ResetMacLabel = 1 Then $LABEL = _SetLables($StripedBSSID)
					$ResetMacLabel = 0
					
					_ListViewAdd($addposition, '', $Text_Active, $MANUF, $TmpArray_Sig[$tmplistval], '', '', '', '', '', '', $newlon, $newlat, '', '', '', $TmpArray_Time[$tmplistval], '', $LABEL)
					
					;Updated data in array
					$DataArray_Active[$listval] = $Text_Active
					$DataArray_BSSID[$listval] = $TmpArray_BSSID[$tmplistval]
					$DataArray_SSID[$listval] = $TmpArray_SSID[$tmplistval]
					$DataArray_Auth[$listval] = $TmpArray_Auth[$tmplistval]
					$DataArray_Encr[$listval] = $TmpArray_Encr[$tmplistval]
					$DataArray_Sig[$listval] = $TmpArray_Sig[$tmplistval]
					$DataArray_Chan[$listval] = $TmpArray_Chan[$tmplistval]
					$DataArray_Rad[$listval] = $TmpArray_Rad[$tmplistval]
					$DataArray_BtX[$listval] = $TmpArray_BtX[$tmplistval]
					$DataArray_OtX[$listval] = $TmpArray_OtX[$tmplistval]
					$DataArray_NetType[$listval] = $TmpArray_NetType[$tmplistval]
					$DataArray_LastTime[$listval] = $TmpArray_Time[$tmplistval]
					$DataArray_SigHist[$listval] = $CurrentSignal
					If $newlon <> '' Then $DataArray_Lon[$listval] = $newlon
					If $newlat <> '' Then $DataArray_Lat[$listval] = $newlat
					If $MANUF <> '' Then $DataArray_Manu[$listval] = $MANUF
					If $LABEL <> '' Then $DataArray_Label[$listval] = $LABEL
					
					;Delete TmpArray row since this is not a new access point
					_ArrayDelete($TmpArray_BSSID, $tmplistval)
					_ArrayDelete($TmpArray_SSID, $tmplistval)
					_ArrayDelete($TmpArray_Auth, $tmplistval)
					_ArrayDelete($TmpArray_Encr, $tmplistval)
					_ArrayDelete($TmpArray_Sig, $tmplistval)
					_ArrayDelete($TmpArray_Chan, $tmplistval)
					_ArrayDelete($TmpArray_Rad, $tmplistval)
					_ArrayDelete($TmpArray_BtX, $tmplistval)
					_ArrayDelete($TmpArray_OtX, $tmplistval)
					_ArrayDelete($TmpArray_NetType, $tmplistval)
					_ArrayDelete($TmpArray_Time, $tmplistval)
					_SetTmpArraySizes()
					ExitLoop
				EndIf
			EndIf
		Next
		If BitAND($addposition = -1, $DataArray_Active[$listval] <> $Text_Dead) = 1 Or $ResetMacLabel = 1 Then
			Dim $MANUF = '', $LABEL = ''
			If $ResetMacLabel = 1 Then
				$StripedBSSID = StringReplace($DataArray_BSSID[$listval], ':', '')
				$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 12))
				$LABEL = _SetLables($StripedBSSID)
				$ResetMacLabel = 0
			EndIf
			$DataArray_Active[$listval] = $Text_Dead
			$DataArray_Sig[$listval] = '0%' 
			_ListViewAdd($DataArray_Row[$listval], '', $Text_Dead, $MANUF, '0%', '', '', '', '', '', '', '', '', '', '', '', '', '', $LABEL)
		EndIf
	Next
	
	For $AddAp = 1 To $TmpArray_BSSID[0]
		$ResetRows = 0
		$TrimmedSignal = StringTrimRight($TmpArray_Sig[$AddAp], 1)


		$StripedBSSID = StringReplace($TmpArray_BSSID[$AddAp], ':', '')
		$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6))
		$LABEL = _SetLables($StripedBSSID)
		$addposition = _GUICtrlListView_InsertItem ($ListviewAPs, $AddDirection, '')
		
		$newrow = $StartArraySize + $AddAp

		_ListViewAdd($addposition, $newrow, $Text_Active, $MANUF, $TmpArray_Sig[$AddAp], $TmpArray_SSID[$AddAp], $TmpArray_BSSID[$AddAp], $TmpArray_Auth[$AddAp], $TmpArray_Encr[$AddAp], $TmpArray_Rad[$AddAp], $TmpArray_Chan[$AddAp], $Latitude, $Longitude, $TmpArray_BtX[$AddAp], $TmpArray_OtX[$AddAp], $TmpArray_Time[$AddAp], $TmpArray_Time[$AddAp], $TmpArray_NetType[$AddAp], $LABEL)

		If $AddDirection = 0 Then
			For $ResetRow = 1 To $DataArray_Row[0]
				$DataArray_Row[$ResetRow] += 1
			Next
		EndIf
		
		;Add data to the treeview
		$TreePosString = _TreeViewAdd($TmpArray_SSID[$AddAp], $TmpArray_BSSID[$AddAp], $TmpArray_Chan[$AddAp], $TmpArray_NetType[$AddAp], $TmpArray_Encr[$AddAp], $TmpArray_Rad[$AddAp], $TmpArray_Auth[$AddAp], $TmpArray_BtX[$AddAp], $TmpArray_OtX[$AddAp], $LABEL)
		;write treeview positions into array for future use
		$TreePos = StringSplit($TreePosString, '|')
		
		;Add AP DATA into the array
		_ArrayInsert($DataArray_Line, 1, $newrow)
		_ArrayInsert($DataArray_Active, 1, "Active")
		_ArrayInsert($DataArray_BSSID, 1, $TmpArray_BSSID[$AddAp])
		_ArrayInsert($DataArray_SSID, 1, $TmpArray_SSID[$AddAp])
		_ArrayInsert($DataArray_Auth, 1, $TmpArray_Auth[$AddAp])
		_ArrayInsert($DataArray_Encr, 1, $TmpArray_Encr[$AddAp])
		_ArrayInsert($DataArray_Sig, 1, $TmpArray_Sig[$AddAp])
		_ArrayInsert($DataArray_Chan, 1, $TmpArray_Chan[$AddAp])
		_ArrayInsert($DataArray_Rad, 1, $TmpArray_Rad[$AddAp])
		_ArrayInsert($DataArray_Lat, 1, $Latitude)
		_ArrayInsert($DataArray_Lon, 1, $Longitude)
		_ArrayInsert($DataArray_BtX, 1, $TmpArray_BtX[$AddAp])
		_ArrayInsert($DataArray_OtX, 1, $TmpArray_OtX[$AddAp])
		_ArrayInsert($DataArray_NetType, 1, $TmpArray_NetType[$AddAp])
		_ArrayInsert($DataArray_FirstTime, 1, $TmpArray_Time[$AddAp])
		_ArrayInsert($DataArray_LastTime, 1, $TmpArray_Time[$AddAp])
		_ArrayInsert($DataArray_SigHist, 1, $TrimmedSignal)
		_ArrayInsert($DataArray_Manu, 1, $MANUF)
		_ArrayInsert($DataArray_Label, 1, $LABEL)
		_ArrayInsert($DataArray_Row, 1, $addposition)
		_ArrayInsert($DataArray_TreeViewSubChannel, 1, $TreePos[1])
		_ArrayInsert($DataArray_TreeViewSubSSID, 1, $TreePos[2])
		_ArrayInsert($DataArray_TreeViewSubEncr, 1, $TreePos[3])
		_ArrayInsert($DataArray_TreeViewSubAuth, 1, $TreePos[4])
		_ArrayInsert($DataArray_TreeViewSubNetType, 1, $TreePos[5])
		
		_SetDataArraySizes()
		$NewApFound = 1
	Next
	If $SoundOnAP = 1 And $NewApFound = 1 Then SoundPlay($SoundDir & $new_AP_sound, 0)
	$NewApFound = 0
	GUICtrlSetData($ActiveAPs, $Active & " / " & $DataArray_BSSID[0])
	;Reset Tmp Arrays to nothing
	Dim $TmpArray_BSSID[1]
	Dim $TmpArray_SSID[1]
	Dim $TmpArray_Auth[1]
	Dim $TmpArray_Encr[1]
	Dim $TmpArray_Sig[1]
	Dim $TmpArray_Chan[1]
	Dim $TmpArray_Rad[1]
	Dim $TmpArray_BtX[1]
	Dim $TmpArray_OtX[1]
	Dim $TmpArray_NetType[1]
	Dim $TmpArray_Time[1]
EndFunc   ;==>_UpdateList

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       LISTVIEW/TREEVIEW FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _TreeViewAdd($SSID, $BSSID, $Channel, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	$channel_treeviewname = StringFormat("%02i", $Channel)
	$SSID_treeviewname = '(' & $SSID & ')' 
	$Encryption_treeviewname = $Encryption
	$Authentication_treeviewname = $Authentication
	$NetworkType_treeviewname = $NetworkType
	;Find If Treeview menu item already exista
	$channel_treeviewposition = -1
	For $t = 1 To $TreeView_Channel_Name[0]
		If $TreeView_Channel_Name[$t] = $channel_treeviewname Then
			$channel_treeviewposition = $TreeView_Channel_Pos[$t]
			ExitLoop
		EndIf
	Next
	$SSID_treeviewposition = -1
	For $t = 1 To $TreeView_SSID_Name[0]
		If $TreeView_SSID_Name[$t] = $SSID_treeviewname Then
			$channel_treeviewposition = $TreeView_SSID_Pos[$t]
			ExitLoop
		EndIf
	Next
	$Encryption_treeviewposition = -1
	For $t = 1 To $TreeView_Encryption_Name[0]
		If $TreeView_Encryption_Name[$t] = $Encryption_treeviewname Then
			$Encryption_treeviewposition = $TreeView_Encryption_Pos[$t]
			ExitLoop
		EndIf
	Next
	$Authentication_treeviewposition = -1
	For $t = 1 To $TreeView_Authentication_Name[0]
		If $TreeView_Authentication_Name[$t] = $Authentication_treeviewname Then
			$Authentication_treeviewposition = $TreeView_Authentication_Pos[$t]
			ExitLoop
		EndIf
	Next
	$NetworkType_treeviewposition = -1
	For $t = 1 To $TreeView_NetworkType_Name[0]
		If $TreeView_NetworkType_Name[$t] = $NetworkType_treeviewname Then
			$NetworkType_treeviewposition = $TreeView_NetworkType_Pos[$t]
			ExitLoop
		EndIf
	Next
	;Add Treeview item if it does not exist
	If $channel_treeviewposition = -1 Then
		$channel_treeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $channel_treeviewname, $channel_tree)
		_ArrayAdd($TreeView_Channel_Name, $channel_treeviewname)
		_ArrayAdd($TreeView_Channel_Pos, $channel_treeviewposition)
	EndIf
	If $SSID_treeviewposition = -1 Then
		$SSID_treeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $SSID_treeviewname, $SSID_tree)
		_ArrayAdd($TreeView_SSID_Name, $SSID_treeviewname)
		_ArrayAdd($TreeView_SSID_Pos, $SSID_treeviewposition)
	EndIf
	If $Encryption_treeviewposition = -1 Then
		$Encryption_treeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Encryption_treeviewname, $Encryption_tree)
		_ArrayAdd($TreeView_Encryption_Name, $Encryption_treeviewname)
		_ArrayAdd($TreeView_Encryption_Pos, $Encryption_treeviewposition)
	EndIf
	If $Authentication_treeviewposition = -1 Then
		$Authentication_treeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $Authentication_treeviewname, $Authentication_tree)
		_ArrayAdd($TreeView_Authentication_Name, $Authentication_treeviewname)
		_ArrayAdd($TreeView_Authentication_Pos, $Authentication_treeviewposition)
	EndIf
	If $NetworkType_treeviewposition = -1 Then
		$NetworkType_treeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, $NetworkType_treeviewname, $NetworkType_tree)
		_ArrayAdd($TreeView_NetworkType_Name, $NetworkType_treeviewname)
		_ArrayAdd($TreeView_NetworkType_Pos, $NetworkType_treeviewposition)
	EndIf
	_SetTreeArraySizes()
	;Create sub menu item for AP details
	$channel_subtreeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, '(' & $SSID & ')', $channel_treeviewposition)
	$SSID_subtreeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, '(' & $SSID & ')', $SSID_treeviewposition)
	$Encryption_subtreeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, '(' & $SSID & ')', $Encryption_treeviewposition)
	$Authentication_subtreeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, '(' & $SSID & ')', $Authentication_treeviewposition)
	$NetworkType_subtreeviewposition = _GUICtrlTreeView_InsertItem ($TreeviewAPs, '(' & $SSID & ')', $NetworkType_treeviewposition)
	
	;Add AP details to sum menu item
	_TreeViewApInfo($channel_subtreeviewposition, $channel_tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	_TreeViewApInfo($SSID_subtreeviewposition, $SSID_tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	_TreeViewApInfo($Encryption_subtreeviewposition, $Encryption_tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	_TreeViewApInfo($Authentication_subtreeviewposition, $Authentication_tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	_TreeViewApInfo($NetworkType_subtreeviewposition, $NetworkType_tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	;Return Treeview positions
	Return ($channel_subtreeviewposition & '|' & $SSID_subtreeviewposition & '|' & $Encryption_subtreeviewposition & '|' & $Authentication_subtreeviewposition & '|' & $NetworkType_subtreeviewposition)
EndFunc   ;==>_TreeViewAdd

Func _TreeViewApInfo($position, ByRef $tree, $SSID, $BSSID, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_SSID & ' : ' & $SSID, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_BSSID & ' : ' & $BSSID, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_NetworkType & ' : ' & $NetworkType, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Encryption & ' : ' & $Encryption, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_RadioType & ' : ' & $RadioType, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Authentication & ' : ' & $Authentication, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_BasicTransferRates & ' : ' & $BasicTransferRates, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_OtherTransferRates & ' : ' & $OtherTransferRates, $position)
	_GUICtrlTreeView_InsertItem ($TreeviewAPs, $Column_Names_Label & ' : ' & $LABEL, $position)
EndFunc   ;==>_TreeViewApInfo

Func _ListViewAdd($line, $Add_Line = '', $Add_Active = '', $Add_MANU = '', $Add_Signal = '', $Add_SSID = '', $Add_BSSID = '', $Add_Authentication = '', $Add_Encryption = '', $Add_RadioType = '', $Add_Channel = '', $Add_Latitude = '', $Add_Longitude = '', $Add_BasicTransferRates = '', $Add_OtherTransferRates = '', $Add_FirstAcvtive = '', $Add_LastActive = '', $Add_NetworkType = '', $Add_Label = '')
	If $Add_Line <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Line, $column_Line)
	If $Add_Active <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Active, $column_Active)
	If $Add_SSID <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_SSID, $column_SSID)
	If $Add_BSSID <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_BSSID, $column_BSSID)
	If $Add_MANU <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_MANU, $column_MANUF)
	If $Add_Signal <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Signal, $column_Signal)
	If $Add_Authentication <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Authentication, $column_Authentication)
	If $Add_Encryption <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Encryption, $column_Encryption)
	If $Add_RadioType <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_RadioType, $column_RadioType)
	If $Add_Channel <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Channel, $column_Channel)
	If $Add_Latitude <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Latitude, $column_Latitude)
	If $Add_Longitude <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Longitude, $column_Longitude)
	If $Add_BasicTransferRates <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_BasicTransferRates, $column_BasicTransferRates)
	If $Add_OtherTransferRates <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_OtherTransferRates, $column_OtherTransferRates)
	If $Add_FirstAcvtive <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_FirstAcvtive, $column_FirstActive)
	If $Add_LastActive <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_LastActive, $column_LastActive)
	If $Add_NetworkType <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_NetworkType, $column_NetworkType)
	If $Add_Label <> '' Then _GUICtrlListView_SetItemText ($ListviewAPs, $line, $Add_Label, $column_Label)
EndFunc   ;==>_ListViewAdd


Func _FindManufacturer($findmac = '')
	Dim $return = 'Unknown' 
	For $searchmaclist = 1 To $manu_mac[0]
		If StringStripWS(StringUpper($manu_mac[$searchmaclist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $manu_manu[$searchmaclist]
			ExitLoop
		EndIf
	Next
	If $findmac = '' Then $return = ''
	Return ($return)
EndFunc   ;==>_FindManufacturer

Func _SetLables($findmac)
	Dim $return = 'Unknown' 
	For $searchlabellist = 1 To $label_mac[0]
		;msgbox(0, $searchlabellist, $label_mac[$searchlabellist])
		If StringStripWS(StringUpper($label_mac[$searchlabellist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $label_label[$searchlabellist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_SetLables

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       TOGGLE/BUTTON FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _CloseToggle()
	$Close = 1
EndFunc   ;==>_CloseToggle

Func _SoundToggle()
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_UNCHECKED)
		$SoundOnAP = 0
	Else
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
		$SoundOnAP = 1
	EndIf
EndFunc   ;==>_SoundToggle

Func _SortColumnToggle()
	$SortColumn = GUICtrlGetState($ListviewAPs)
EndFunc   ;==>_SortColumnToggle


Func _AddApPosToggle()
	If GUICtrlRead($AddNewAPsToTop) = 65 Then
		GUICtrlSetState($AddNewAPsToTop, $GUI_UNCHECKED)
		$AddDirection = -1
		_FixLineNumbers()
	Else
		GUICtrlSetState($AddNewAPsToTop, $GUI_CHECKED)
		$AddDirection = 0
		_FixLineNumbers()
	EndIf
EndFunc   ;==>_AddApPosToggle

Func _TurnOffGPS()
	$UseGPS = 0
	$TurnOffGPS = 0
	$disconnected_time = -1
	$Latitude = 'N 0.0000000' 
	$Longitude = 'E 0.0000000' 
	_CloseComPort($ComPort) ;Close The GPS COM port
	GUICtrlSetState($UseGpsGUI, $GUI_UNCHECKED)
	GUICtrlSetData($GpsButton, $Text_UseGPS)
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_TurnOffGPS

Func _GpsToggle()
	If $UseGPS = 1 Then
		$TurnOffGPS = 1
	Else
		$openport = _OpenComPort($ComPort, $BAUD);Open The GPS COM port
		If $openport = 1 Then
			$UseGPS = 1
			GUICtrlSetState($UseGpsGUI, $GUI_CHECKED)
			GUICtrlSetData($GpsButton, $Text_StopGPS)
			$GPGGA_Update = TimerInit()
			$GPGMC_Update = TimerInit()
		Else
			$UseGPS = 0
			GUICtrlSetData($msgdisplay, 'Error opening GPS port')
		EndIf
	EndIf
EndFunc   ;==>_GpsToggle

Func _SortToggle()
	If $AutoSort = 1 Then
		$AutoSort = 0
		GUICtrlSetState($AutoSortGUI, $GUI_UNCHECKED)
	Else
		$AutoSort = 1
		GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
		$sort_timer = TimerInit()
	EndIf
EndFunc   ;==>_SortToggle

Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetState($ScanWifiGUI, $GUI_UNCHECKED)
		GUICtrlSetData($ScanButton, $Text_ScanAPs)
	Else
		$Scan = 1
		GUICtrlSetState($ScanWifiGUI, $GUI_CHECKED)
		GUICtrlSetData($ScanButton, $Text_StopScanAps)
	EndIf
EndFunc   ;==>ScanToggle

Func _GraphToggle()
	If $Graph = 1 Then
		_DeletePens()
		_DrawingShutDown($GraphicGUI)
		$Graph = 0
		GUICtrlSetData($GraphButton1, $Text_Graph1)
		GUISwitch($Vistumbler)
		GUISetState(@SW_HIDE, $GraphicGUI)
	ElseIf $Graph = 2 Then
		$Graph = 1
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton1, $Text_NoGraph)
		GUICtrlSetData($GraphButton2, $Text_Graph2)
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		_DrawingStartUp($GraphicGUI)
		_CreatePens()
		$Graph = 1
		GUICtrlSetData($GraphButton1, $Text_NoGraph)
		GUISwitch($Vistumbler)
		GUISetState(@SW_SHOW, $GraphicGUI)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle

Func _GraphToggle2()
	If $Graph = 2 Then
		_DeletePens()
		_DrawingShutDown($GraphicGUI)
		$Graph = 0
		GUICtrlSetData($GraphButton2, $Text_Graph2)
		GUISwitch($Vistumbler)
		GUISetState(@SW_HIDE, $GraphicGUI)
	ElseIf $Graph = 1 Then
		$Graph = 2
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton2, $Text_NoGraph)
		GUICtrlSetData($GraphButton1, $Text_Graph1)
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		_DrawingStartUp($GraphicGUI)
		_CreatePens()
		$Graph = 2
		GUICtrlSetData($GraphButton2, $Text_NoGraph)
		GUISwitch($Vistumbler)
		GUISetState(@SW_SHOW, $GraphicGUI)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle2

Func _ExitVistumbler()
	If $newdata = 1 Then ;If Access point data has changed since load/last save, ask user if they want to save the data
		$savemsg = MsgBox(3, $Text_Save, $Text_SaveQuestion)
		If $savemsg <> 2 Then
			If $savemsg = 6 Then _ExportData()
			_Exit()
		EndIf
	Else
		_Exit()
	EndIf
	$Close = 0
EndFunc   ;==>_ExitVistumbler

Func _Exit()
	GUISetState(@SW_HIDE, $Vistumbler)
	_WriteINI(); Write current settings to back to INI file
	If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
		_TurnOffGPS()
		Exit
	Else
		Exit
	EndIf
EndFunc   ;==>_Exit

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GPS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _OpenComPort($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1');Open specified COM port
	If $UseNetcomm = 1 Then
		$return = 0
		$ComError = 0
		$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
		;	Create NETComm.ocx object
		$NetComm = ObjCreate("NETCommOCX.NETComm")
		If IsObj($NetComm) = 0 Then ;If $NetComm is not an object then netcomm ocx is probrably not installed
			MsgBox(0, '', 'Install Netcomm OCX')
		Else
			$NetComm.CommPort = $CommPort ;Set port number
			$NetComm.Settings = $CommSettings ;Set port settings
			$NetComm.InputLen = 0 ;reads entire buffer
			If $ComError <> 1 Then
				$NetComm.InputMode = 0 ;reads in text mode
				$NetComm.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
				$NetComm.PortOpen = "True" 
				$return = 1
			EndIf
		EndIf
		Return ($return)
	Else
		Dim $iBits = 8, $iPar = 0, $iStop = 1, $iFlow = 0
		$OpenedPort = _CommSetPort ($CommPort, $sErr, $sBAUD, $iBits, $iPar, $iStop, $iFlow)
		If $OpenedPort = 1 Then
			Return (1)
		Else
			Return (0)
		EndIf
	EndIf
EndFunc   ;==>_OpenComPort

Func _CloseComPort($CommPort = '8');Closes specified COM port
	;Close the COM Port
	If $UseNetcomm = 1 Then
		With $NetComm
			.CommPort = $CommPort ;Set port number
			.PortOpen = "False" 
		EndWith
	Else
		_CommClosePort ()
	EndIf
EndFunc   ;==>_CloseComPort

Func _GetGPS()
	$timeout = TimerInit()
	$return = 1
	
	$maxtime = GUICtrlRead($sleeptime) * 0.8; Set GPS timeout to 80% of the given timout time
	If $maxtime < 800 Then $maxtime = 800;Set GPS timeout to 800 if it is under that
	
	Dim $Temp_FixTime, $Temp_FixTime2, $Temp_FixDate, $Temp_Lat, $Temp_Lon, $Temp_Lat2, $Temp_Lon2, $Temp_Quality, $Temp_NumberOfSatalites, $Temp_HorDilPitch, $Temp_Alt, $Temp_AltS, $Temp_Geo, $Temp_GeoS, $Temp_Status, $Temp_SpeedInKnots, $Temp_SpeedInMPH, $Temp_SpeedInKmH, $Temp_TrackAngle
	Dim $Temp_Quality = 0, $Temp_Status = "V" 
	
	If $UseNetcomm = 1 Then ;Use Netcomm ocx to get data (more stable right now)
		While 1 ;Loop to extract gps data untill location is found or timout time is reached
			If $UseGPS = 0 Then ExitLoop
			If $NetComm.InBufferCount Then
				$Buffer = $NetComm.InBufferCount
				If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
					$inputdata = $NetComm.inputdata
					$gps = StringSplit($inputdata, "$")
					For $readloop = 1 To $gps[0]
						If $GpsDetailsOpen = 1 Then GUICtrlSetData($GpsCurrentDataGUI, $gps[$readloop]);Show data line in "GPS Details" GUI if it is open
						If StringInStr($gps[$readloop], "GPGGA") Then
							_GPGGA($gps[$readloop]);Split GPGGA data from data string
						ElseIf StringInStr($gps[$readloop], "GPRMC") Then
							_GPGMC($gps[$readloop]);Split GPGMC data from data string
						EndIf
						If $Temp_Quality = 1 And BitOR($Temp_Status = "A", $GpsDetailsOpen <> 1) Then ExitLoop;If $Temp_Quality = 1 (GPS has a fix) And, If the details window is open, $Temp_Status = "A" (Active data, not Void)
						If TimerDiff($timeout) > $maxtime Then ExitLoop;If time is over timeout period, exitloop
					Next
				EndIf
				If TimerDiff($timeout) > $maxtime Then
					GUICtrlSetData($msgdisplay, 'GPS Timeout')
					ExitLoop
				EndIf
				Sleep($maxtime / 100)
				$disconnected_time = TimerInit() ;reset gps turn off timer
			Else
				If $disconnected_time = -1 Then $disconnected_time = TimerInit()
				If TimerDiff($disconnected_time) > 10000 Then ; If nothing has been found in the buffer for 5 seconds, turn off gps
					$disconnected_time = -1
					$return = 0
					_TurnOffGPS()
					SoundPlay($SoundDir & $error_sound, 0)
				EndIf
			EndIf
		WEnd
	Else ;Use CommMG.dll instead of the netcomm ocx (less stable, but works with x64)
		While 1
			$dataline = StringStripWS(_CommGetLine (), 8);Read data line from GPS
			If $GpsDetailsOpen = 1 Then GUICtrlSetData($GpsCurrentDataGUI, $dataline);Show data line in "GPS Details" GUI if it is open
			If StringInStr($dataline, "GPGGA") Then
				_GPGGA($dataline);Split GPGGA data from data string
			ElseIf StringInStr($dataline, "GPRMC") Then
				_GPGMC($dataline);Split GPGMC data from data string
			EndIf
			If $Temp_Quality = 1 And BitOR($Temp_Status = "A", $GpsDetailsOpen <> 1) Then ExitLoop;If $Temp_Quality = 1 (GPS has a fix) And, If the details window is open, $Temp_Status = "A" (Active data, not Void)
			If TimerDiff($timeout) > $maxtime Then ExitLoop;If time is over timeout period, exitloop
		WEnd
	EndIf
	
	If $Temp_Quality = 1 Then ;If the GPGGA data has a fix(1) then write data to perminant variables
		If $FixTime <> $Temp_FixTime Then $GPGGA_Update = TimerInit()
		$FixTime = $Temp_FixTime
		$Latitude = $Temp_Lat
		$Longitude = $Temp_Lon
		$NumberOfSatalites = $Temp_NumberOfSatalites
		$HorDilPitch = $Temp_HorDilPitch
		$Alt = $Temp_Alt
		$AltS = $Temp_AltS
		$Geo = $Temp_Geo
		$GeoS = $Temp_GeoS
	EndIf
	If $Temp_Status = "A"  Then ;If the GPGMC data is Active(A) then write data to perminant variables
		If $FixTime2 <> $Temp_FixTime2 Then $GPGMC_Update = TimerInit()
		$FixTime2 = $Temp_FixTime2
		$Latitude2 = $Temp_Lat2
		$Longitude2 = $Temp_Lon2
		$SpeedInKnots = $Temp_SpeedInKnots
		$SpeedInMPH = $Temp_SpeedInMPH
		$SpeedInKmH = $Temp_SpeedInKmH
		$TrackAngle = $Temp_TrackAngle
		$FixDate = $Temp_FixDate
	EndIf
	_ClearGpsDetailsGUI();Reset variables if they are over the allowed timeout
	_UpdateGpsDetailsGUI();Write changes to "GPS Details" GUI if it is open
	_DrawCompassLine($TrackAngle, 50)
	
	If $TurnOffGPS = 1 Then _TurnOffGPS()
	
	Return ($return)
EndFunc   ;==>_GetGPS

Func _GPGGA($data)
	GUICtrlSetData($msgdisplay, $data)
	$GPGGA_Split = StringSplit($data, ",");
	If $GPGGA_Split[0] >= 13 Then
		$Temp_Quality = $GPGGA_Split[7]
		If $Temp_Quality = 1 Then
			$Temp_FixTime = $GPGGA_Split[2]
			$Temp_Lat = _FormatLatLon($GPGGA_Split[3], $GPGGA_Split[4])
			$Temp_Lon = _FormatLatLon($GPGGA_Split[5], $GPGGA_Split[6])
			$Temp_NumberOfSatalites = $GPGGA_Split[8]
			$Temp_HorDilPitch = $GPGGA_Split[9]
			$Temp_Alt = $GPGGA_Split[10] * 3.2808399
			$Temp_AltS = $GPGGA_Split[11]
			$Temp_Geo = $GPGGA_Split[12]
			$Temp_GeoS = $GPGGA_Split[13]
		EndIf
	EndIf
EndFunc   ;==>_GPGGA

Func _GPGMC($data)
	GUICtrlSetData($msgdisplay, $data)
	$GPGMC_Split = StringSplit($data, ",")
	If $GPGMC_Split[0] >= 10 Then
		$Temp_Status = $GPGMC_Split[3]
		If $Temp_Status = "A"  Then
			$Temp_FixTime2 = $GPGMC_Split[2]
			$Temp_Lat2 = _FormatLatLon($GPGMC_Split[4], $GPGMC_Split[5])
			$Temp_Lon2 = _FormatLatLon($GPGMC_Split[6], $GPGMC_Split[7])
			$Temp_SpeedInKnots = $GPGMC_Split[8]
			$Temp_SpeedInMPH = Round($GPGMC_Split[8] * 1.15, 2) & " MPH" 
			$Temp_SpeedInKmH = Round($GPGMC_Split[8] * 1.85200, 2) & " km/h" 
			$Temp_TrackAngle = $GPGMC_Split[9]
			$Temp_FixDate = $GPGMC_Split[10]
		EndIf
	EndIf
EndFunc   ;==>_GPGMC

Func _FormatLatLon($inLatLon, $inLatLonNSWE)
	$return = ''
	$splitlatlon = StringSplit($inLatLon, ".")
	If $splitlatlon[0] = 2 Then
		$LatLonD = StringMid((StringRight($splitlatlon[1], 2) & "." & StringRight($splitlatlon[2], 4)) / 60, 2, 10)
		$ufLatLon = StringLeft($splitlatlon[1], StringLen($splitlatlon[1]) - 2) & $LatLonD
		$return = $inLatLonNSWE & ' ' & StringFormat('%0.7f', $ufLatLon);set return
	EndIf
	Return ($return)
EndFunc   ;==>_FormatLatLon

Func _GPSOptions()
	$CloseGpsGUI = 0
	Opt("GUIOnEventMode", 0)  ; Turn Off OnEvent mode
	$GpsOptions = GUICreate($Text_GpsSettings, 260, 200, -1, -1)
	GUISetBkColor($BackgroundColor)
	$GUI_UseGPS = GUICtrlCreateCheckbox($Text_UseGPS, 104, 8, 73, 17)
	If $UseGPS = 1 Then GUICtrlSetState($GUI_UseGPS, $GUI_CHECKED)
	$Rad_UseNetcomm = GUICtrlCreateRadio("Use Netcomm OCX (more stable) - x32", 24, 32, 209, 17)
	$Rad_UseCommMG = GUICtrlCreateRadio("Use CommMG (less stable) - x32 - x64", 24, 56, 209, 17)
	If $UseNetcomm = 1 Then
		GUICtrlSetState($Rad_UseNetcomm, $GUI_CHECKED)
	Else
		GUICtrlSetState($Rad_UseCommMG, $GUI_CHECKED)
	EndIf
	GUICtrlCreateLabel("Com:", 24, 88, 28, 17)
	$GUI_Comport = GUICtrlCreateCombo("1", 64, 88, 161, 25)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $ComPort)
	GUICtrlCreateLabel("Baud:", 24, 120, 32, 17)
	$GUI_Baud = GUICtrlCreateCombo("4800", 64, 120, 161, 25)
	GUICtrlSetData(-1, "9600|14400|19200|38400|57600|115200", $BAUD)
	$GPS_OK = GUICtrlCreateButton($Text_Ok, 40, 155, 81, 25, 0)
	$GPS_Cancel = GUICtrlCreateButton($Text_Cancel, 136, 155, 81, 25, 0)
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $GPS_Cancel
				ExitLoop
			Case $GPS_OK
				If GUICtrlRead($GUI_Comport) <> $ComPort And $UseGPS = 1 Then _GpsToggle() ;If the port has changed and gps is turned on then turn off the gps (it will be re-enabled with the new port)
				$ComPort = GUICtrlRead($GUI_Comport)
				$BAUD = GUICtrlRead($GUI_Baud)
				If GUICtrlRead($GUI_UseGPS) = 4 And $UseGPS = 1 Then _GpsToggle()
				If GUICtrlRead($GUI_UseGPS) = 1 And $UseGPS = 0 Then _GpsToggle()
				If GUICtrlRead($Rad_UseNetcomm) = 1 Then $UseNetcomm = 1 ;Set Netcomm as default comm interface
				If GUICtrlRead($Rad_UseCommMG) = 1 Then $UseNetcomm = 0 ;Set CommMG as default comm interface
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($GpsOptions)
EndFunc   ;==>_GPSOptions

Func _OpenGpsDetailsGUI()
	If $GpsDetailsOpen = 0 Then
		$GpsDetailsGUI = GUICreate($Text_GpsDetails, 600, 345, -1, -1)
		GUISetBkColor($BackgroundColor)
		$GpsCurrentDataGUI = GUICtrlCreateLabel('', 8, 10, 450, 40)
		GUICtrlCreateLabel("N", 556, 0, 15, 15)
		GUICtrlCreateLabel("S", 556, 67, 15, 15)
		GUICtrlCreateLabel("E", 587, 35, 15, 15)
		GUICtrlCreateLabel("W", 520, 35, 15, 15)
		$CompassGraphic = GUICtrlCreateGraphic(535, 15, 50, 50)
		GUICtrlSetBkColor($CompassGraphic, $ControlBackgroundColor)
		$GPGGA_Quality = GUICtrlCreateLabel($Text_Quality & ":", 32, 55, 235, 20)
		$GPGMC_Status = GUICtrlCreateLabel($Text_Status & ":", 310, 55, 200, 20)
		GUICtrlCreateGroup("GPGGA", 8, 80, 273, 225)
		$GPGGA_Time = GUICtrlCreateLabel($Text_Time & ":", 25, 100, 235, 20)
		$GPGGA_Satalites = GUICtrlCreateLabel($Text_NumberOfSatalites & ":", 25, 125, 235, 20)
		$GPGGA_Lat = GUICtrlCreateLabel($Column_Names_Latitude & ":", 25, 150, 235, 20)
		$GPGGA_Lon = GUICtrlCreateLabel($Column_Names_Longitude & ":", 25, 175, 235, 20)
		$GPGGA_HorDilPitch = GUICtrlCreateLabel($Text_HorizontalDilutionPosition & ":", 25, 200, 235, 20)
		$GPGGA_Alt = GUICtrlCreateLabel($Text_Altitude & ":", 25, 225, 243, 20)
		$GPGGA_Geo = GUICtrlCreateLabel($Text_HeightOfGeoid & ":", 25, 250, 243, 20)
		GUICtrlCreateGroup("", -99, -99, 1, 1)
		GUICtrlCreateGroup("GPGMC", 287, 80, 273, 225)
		$GPGMC_Time = GUICtrlCreateLabel($Text_Time & ":", 304, 100, 235, 20)
		$GPGMC_Date = GUICtrlCreateLabel($Text_Date & ":", 304, 125, 235, 20)
		$GPGMC_Lat = GUICtrlCreateLabel($Column_Names_Latitude & ":", 304, 150, 235, 20)
		$GPGMC_Lon = GUICtrlCreateLabel($Column_Names_Longitude & ":", 304, 175, 235, 20)
		$GPGMC_SpeedKnots = GUICtrlCreateLabel($Text_SpeedInKnots & ":", 304, 200, 235, 20)
		$GPGMC_SpeedMPH = GUICtrlCreateLabel($Text_SpeedInMPH & ":", 304, 225, 243, 20)
		$GPGMC_SpeedKmh = GUICtrlCreateLabel($Text_SpeedInKmh & ":", 304, 250, 243, 20)
		$GPGMC_TrackAngle = GUICtrlCreateLabel($Text_TrackAngle & ":", 304, 275, 243, 20)
		GUICtrlCreateGroup("", -99, -99, 1, 1)
		$CloseGpsDetailsGUI = GUICtrlCreateButton($Text_Close, 232, 312, 97, 25, 0)
		GUICtrlSetOnEvent($CloseGpsDetailsGUI, '_CloseGpsDetailsGUI')
		GUISetState(@SW_SHOW)
		$GpsDetailsOpen = 1
	EndIf
EndFunc   ;==>_OpenGpsDetailsGUI

Func _UpdateGpsDetailsGUI()
	If $GpsDetailsOpen = 1 Then
		GUICtrlSetData($GPGGA_Time, $Text_Time & ": " & $FixTime)
		GUICtrlSetData($GPGGA_Lat, $Column_Names_Latitude & ": " & $Latitude)
		GUICtrlSetData($GPGGA_Lon, $Column_Names_Longitude & ": " & $Longitude)
		GUICtrlSetData($GPGGA_Quality, $Text_Quality & ": " & $Temp_Quality & @CRLF)
		GUICtrlSetData($GPGGA_Satalites, $Text_NumberOfSatalites & ": " & $NumberOfSatalites & @CRLF)
		GUICtrlSetData($GPGGA_HorDilPitch, $Text_HorizontalDilutionPosition & ": " & $HorDilPitch & @CRLF)
		GUICtrlSetData($GPGGA_Alt, $Text_Altitude & ": " & $Alt & $AltS & @CRLF)
		GUICtrlSetData($GPGGA_Geo, $Text_HeightOfGeoid & ": " & $Geo & $GeoS & @CRLF)
		
		GUICtrlSetData($GPGMC_Time, $Text_Time & ": " & $FixTime2 & @CRLF)
		GUICtrlSetData($GPGMC_Date, $Text_Date & ": " & $FixDate & @CRLF)
		GUICtrlSetData($GPGMC_Lat, $Column_Names_Latitude & ": " & $Latitude2 & @CRLF)
		GUICtrlSetData($GPGMC_Lon, $Column_Names_Longitude & ": " & $Longitude2 & @CRLF)
		GUICtrlSetData($GPGMC_Status, $Text_Status & ": " & $Temp_Status & @CRLF)
		GUICtrlSetData($GPGMC_SpeedKnots, $Text_SpeedInKnots & ": " & $SpeedInKnots & @CRLF)
		GUICtrlSetData($GPGMC_SpeedMPH, $Text_SpeedInMPH & ": " & $SpeedInMPH & @CRLF)
		GUICtrlSetData($GPGMC_SpeedKmh, $Text_SpeedInKmh & ": " & $SpeedInKmH & @CRLF)
		GUICtrlSetData($GPGMC_TrackAngle, $Text_TrackAngle & ": " & $TrackAngle & @CRLF)
	EndIf
EndFunc   ;==>_UpdateGpsDetailsGUI

Func _ClearGpsDetailsGUI()
	GUICtrlSetData($msgdisplay, "Seconds Since GPS GPGGA Update: " & Round(TimerDiff($GPGGA_Update) / 1000) & " / " & ($GpsTimeout / 1000) & " - " & "Seconds Since GPS GPGMC Update: " & Round(TimerDiff($GPGMC_Update) / 1000) & " - " & ($GpsTimeout / 1000))
	If Round(TimerDiff($GPGGA_Update)) > $GpsTimeout Then
		$FixTime = ''
		$Latitude = 'N 0.0000000' 
		$Longitude = 'E 0.0000000' 
		$NumberOfSatalites = ''
		$HorDilPitch = ''
		$Alt = ''
		$AltS = ''
		$Geo = ''
		$GeoS = ''
		$GPGGA_Update = TimerInit()
	EndIf
	If Round(TimerDiff($GPGMC_Update)) > $GpsTimeout Then
		$FixTime2 = ''
		$Latitude2 = 'N 0.0000000' 
		$Longitude2 = 'E 0.0000000' 
		$SpeedInKnots = ''
		$SpeedInMPH = ''
		$SpeedInKmH = ''
		$TrackAngle = ''
		$FixDate = ''
		$GPGMC_Update = TimerInit()
	EndIf
EndFunc   ;==>_ClearGpsDetailsGUI

Func _CloseGpsDetailsGUI()
	GUIDelete($GpsDetailsGUI)
	$GpsDetailsOpen = 0
EndFunc   ;==>_CloseGpsDetailsGUI

Func _DrawCompassLine($Degree, $CompassHeight)
	If $GpsDetailsOpen = 1 Then
		GUISwitch($GpsDetailsGUI)
		GUICtrlDelete($CompassGraphic)
		$CompassGraphic = GUICtrlCreateGraphic(535, 15, 50, 50)
		GUICtrlSetBkColor($CompassGraphic, $ControlBackgroundColor)
		$Radius = ($CompassHeight / 2) - 1
		$CenterX = ($CompassHeight / 2)
		$CenterY = ($CompassHeight / 2)

		;Calculate (X, Y) based on Degrees, Radius, And Center of circle (X, Y)
		If $Degree = 0 Or $Degree = 360 Then
			$CircleX = $CenterX
			$CircleY = $CenterY - $Radius
		ElseIf $Degree > 0 And $Degree < 90 Then
			$Radians = $Degree * 0.0174532925
			$CircleX = $CenterX + (Sin($Radians) * $Radius)
			$CircleY = $CenterY - (Cos($Radians) * $Radius)
		ElseIf $Degree = 90 Then
			$CircleX = $CenterX + $Radius
			$CircleY = $CenterY
		ElseIf $Degree > 90 And $Degree < 180 Then
			$TmpDegree = $Degree - 90
			$Radians = $TmpDegree * 0.0174532925
			$CircleX = $CenterX + (Cos($Radians) * $Radius)
			$CircleY = $CenterY + (Sin($Radians) * $Radius)
		ElseIf $Degree = 180 Then
			$CircleX = $CenterX
			$CircleY = $CenterY + $Radius
		ElseIf $Degree > 180 And $Degree < 270 Then
			$TmpDegree = $Degree - 180
			$Radians = $TmpDegree * 0.0174532925
			$CircleX = $CenterX - (Sin($Radians) * $Radius)
			$CircleY = $CenterY + (Cos($Radians) * $Radius)
		ElseIf $Degree = 270 Then
			$CircleX = $CenterX - $Radius
			$CircleY = $CenterY
		ElseIf $Degree > 270 And $Degree < 360 Then
			$TmpDegree = $Degree - 270
			$Radians = $TmpDegree * 0.0174532925
			$CircleX = $CenterX - (Cos($Radians) * $Radius)
			$CircleY = $CenterY - (Sin($Radians) * $Radius)
		EndIf
		
		;Draw Compass
		GUICtrlSetGraphic($CompassGraphic, $GUI_GR_ELLIPSE, 1, 1, $CompassHeight - 2, $CompassHeight - 2);Draw compass cicle
		GUICtrlSetGraphic($CompassGraphic, $GUI_GR_MOVE, $CenterX, $CenterY);Move to center of the circle
		GUICtrlSetGraphic($CompassGraphic, $GUI_GR_LINE, $CircleX, $CircleY);Draw line from center to calculated point
		GUICtrlSetGraphic($CompassGraphic, $GUI_GR_REFRESH);Show changes
		;GUISwitch($Vistumbler)
	EndIf
EndFunc   ;==>_DrawCompassLine

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SORT FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SortTree()
	GUICtrlSetData($msgdisplay, 'Sorting Treeview')
	_GUICtrlTreeView_Sort ($TreeviewAPs)
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_SortTree


Func _SortOptions()
	Opt("GUIOnEventMode", 0)
	
	$SortOptions = GUICreate($Text_AutoSort, 225, 171, -1, -1)
	GUISetBkColor($BackgroundColor)
	$GUI_AutoSort = GUICtrlCreateCheckbox($Text_AutoSort, 72, 8, 73, 17)
	If $AutoSort = 1 Then GUICtrlSetState($GUI_AutoSort, $GUI_CHECKED)
	$GUI_SortBy = GUICtrlCreateCombo('Sort By SSID', 8, 40, 201, 25)
	GUICtrlSetData(-1, 'Sort By Network Type|Sort By Authentication|Sort By Encryption|Sort By BSSID|Sort By Signal|Sort By Radio Type|Sort By Channel|Sort By Basic Transfer Rates|Sort By Other Transfer Rates|Sort By Latitude|Sort By Longitude|Sort By First Active|Sort By Last Active|Sort By Active|Sort By Manufacturer', $SortBy)
	$GUI_SortDirection = GUICtrlCreateCombo('Ascending', 7, 73, 201, 25)
	GUICtrlSetData(-1, 'Decending', $SortDirection)
	GUICtrlCreateLabel("Auto Sort every:", 24, 104, 80, 17)
	$GUI_SortTime = GUICtrlCreateInput($SortTime, 112, 104, 33, 21)
	GUICtrlCreateLabel("Seconds", 152, 104, 46, 17)
	$Sort_OK = GUICtrlCreateButton($Text_Ok, 32, 135, 73, 25, 0)
	$Sort_Cancel = GUICtrlCreateButton($Text_Cancel, 117, 135, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $Sort_Cancel
				ExitLoop
			Case $Sort_OK
				$SortBy = GUICtrlRead($GUI_SortBy)
				$SortDirection = GUICtrlRead($GUI_SortDirection)
				$SortTime = GUICtrlRead($GUI_SortTime)
				If GUICtrlRead($GUI_AutoSort) = 4 And $AutoSort = 1 Then _SortToggle()
				If GUICtrlRead($GUI_AutoSort) = 1 And $AutoSort = 0 Then _SortToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($SortOptions)
EndFunc   ;==>_SortOptions

Func _HeaderSort($column)
	GUICtrlSetData($msgdisplay, 'Sorting List')
	If $Direction[$column] = 'Ascending'  Then
		Dim $v_sort = False;Dim $v_sort = _GUICtrlListView_GetColumnCount ($ListviewAPs)
	Else
		Dim $v_sort = True;Dim $v_sort[_GUICtrlListView_GetColumnCount ($ListviewAPs) ]
	EndIf
	If $Direction[$column] = 'Ascending'  Then
		$Direction[$column] = 'Decending' 
	Else
		$Direction[$column] = 'Ascending' 
	EndIf
	_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column)
	_FixLineNumbers()
	$SortColumn = -1
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_HeaderSort

Func _HeaderSort2($column)
	If $Direction2[$column] = 'Ascending'  Then
		Dim $v_sort = False;Dim $v_sort = _GUICtrlListView_GetColumnCount ($GUIList)
	Else
		Dim $v_sort = True;Dim $v_sort[_GUICtrlListView_GetColumnCount ($GUIList) ]
	EndIf
	If $Direction2[$column] = 'Ascending'  Then
		$Direction2[$column] = 'Decending' 
	Else
		$Direction2[$column] = 'Ascending' 
	EndIf
	_GUICtrlListView_SimpleSort ($GUIList, $v_sort, $column)
EndFunc   ;==>_HeaderSort2

Func _Sort($Sort)
	If $AddDirection = 0 Then
		Dim $v_sort = False;$v_sort = _GUICtrlListView_GetColumnCount ($ListviewAPs) ;set ascending
	Else
		Dim $v_sort = True;$v_sort[_GUICtrlListView_GetColumnCount ($ListviewAPs) ] ;set descending
	EndIf
	
	If $Sort = 'Sort By SSID'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_SSID)
	ElseIf $Sort = 'Sort By Network Type'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_NetworkType)
	ElseIf $Sort = 'Sort By Authentication'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Authentication)
	ElseIf $Sort = 'Sort By Encryption'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Encryption)
	ElseIf $Sort = 'Sort By BSSID'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_BSSID)
	ElseIf $Sort = 'Sort By Signal'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Signal)
	ElseIf $Sort = 'Sort By Radio Type'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_RadioType)
	ElseIf $Sort = 'Sort By Channel'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Channel)
	ElseIf $Sort = 'Sort By Basic Transfer Rates'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_BasicTransferRates)
	ElseIf $Sort = 'Sort By Other Transfer Rates'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_OtherTransferRates)
	ElseIf $Sort = 'Sort By Latitude'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Longitude)
	ElseIf $Sort = 'Sort By Longitude'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Latitude)
	ElseIf $Sort = 'Sort By First Active'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_FirstActive)
	ElseIf $Sort = 'Sort By Last Active'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_LastActive)
	ElseIf $Sort = 'Sort By Active'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_Active)
	ElseIf $Sort = 'Sort By Manufacturer'  Then
		_GUICtrlListView_SimpleSort ($ListviewAPs, $v_sort, $column_MANUF)
	EndIf
	
	_FixLineNumbers()
	$sort_timer = TimerInit()
EndFunc   ;==>_Sort

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SEARCHWORDS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SearchWordsGUI()
	Opt("GUIOnEventMode", 0)
	$SearchWordsGUI = GUICreate("netsh search words", 366, 450, -1, -1)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateGroup("Description", 8, 8, 345, 81)
	GUICtrlCreateLabel("This section allows you to change the words Vistumbler uses to search", 13, 24, 336, 17)
	GUICtrlCreateLabel("netsh. Change to the proper words for you version of windows.", 13, 43, 298, 17)
	GUICtrlCreateLabel("Run 'netsh wlan show networks mode=bssid' to find the proper words.", 13, 64, 332, 17)
	GUICtrlCreateLabel($Column_Names_SSID & ":", 8, 96, 106, 17)
	GUICtrlCreateLabel($Column_Names_BSSID & ":", 8, 128, 106, 17)
	GUICtrlCreateLabel($Column_Names_NetworkType & ":", 8, 160, 106, 17)
	GUICtrlCreateLabel($Column_Names_Authentication & ":", 8, 192, 106, 17)
	GUICtrlCreateLabel($Column_Names_Signal & ":", 8, 224, 106, 17)
	GUICtrlCreateLabel($Column_Names_RadioType & ":", 8, 256, 106, 17)
	GUICtrlCreateLabel($Column_Names_Channel & ":", 8, 288, 106, 17)
	GUICtrlCreateLabel($Column_Names_BasicTransferRates & ":", 8, 320, 106, 17)
	GUICtrlCreateLabel($Column_Names_OtherTransferRates & ":", 8, 352, 106, 17)
	GUICtrlCreateLabel($Column_Names_Encryption & ":", 8, 384, 106, 17)
	$SearchWord_SSID_GUI = GUICtrlCreateInput($SearchWord_SSID, 120, 96, 233, 21)
	$SearchWord_BSSID_GUI = GUICtrlCreateInput($SearchWord_BSSID, 120, 128, 233, 21)
	$SearchWord_NetType_GUI = GUICtrlCreateInput($SearchWord_NetworkType, 120, 160, 233, 21)
	$SearchWord_Authentication_GUI = GUICtrlCreateInput($SearchWord_Authentication, 120, 192, 233, 21)
	$SearchWord_Signal_GUI = GUICtrlCreateInput($SearchWord_Signal, 120, 224, 233, 21)
	$SearchWord_RadioType_GUI = GUICtrlCreateInput($SearchWord_RadioType, 120, 256, 233, 21)
	$SearchWord_Channel_GUI = GUICtrlCreateInput($SearchWord_Channel, 120, 288, 233, 21)
	$SearchWord_BasicRates_GUI = GUICtrlCreateInput($SearchWord_BasicRates, 120, 320, 233, 21)
	$SearchWord_OtherRates_GUI = GUICtrlCreateInput($SearchWord_OtherRates, 120, 352, 233, 21)
	$SearchWord_Encryption_GUI = GUICtrlCreateInput($SearchWord_Encryption, 120, 384, 233, 21)
	$SearchWordsGUI_OK = GUICtrlCreateButton($Text_Ok, 110, 416, 75, 25, 0)
	$SearchWordsGUI_Cancel = GUICtrlCreateButton($Text_Cancel, 190, 416, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $SearchWordsGUI_Cancel
				ExitLoop
			Case $SearchWordsGUI_OK
				$SearchWord_SSID = GUICtrlRead($SearchWord_SSID_GUI)
				$SearchWord_BSSID = GUICtrlRead($SearchWord_BSSID_GUI)
				$SearchWord_NetworkType = GUICtrlRead($SearchWord_NetType_GUI)
				$SearchWord_Authentication = GUICtrlRead($SearchWord_Authentication_GUI)
				$SearchWord_Signal = GUICtrlRead($SearchWord_Signal_GUI)
				$SearchWord_RadioType = GUICtrlRead($SearchWord_RadioType_GUI)
				$SearchWord_Channel = GUICtrlRead($SearchWord_Channel_GUI)
				$SearchWord_BasicRates = GUICtrlRead($SearchWord_BasicRates_GUI)
				$SearchWord_OtherRates = GUICtrlRead($SearchWord_OtherRates_GUI)
				$SearchWord_Encryption = GUICtrlRead($SearchWord_Encryption_GUI)
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($SearchWordsGUI)
EndFunc   ;==>_SearchWordsGUI

Func _SelectLanguage()
	Opt("GUIOnEventMode", 0)
	Dim $Languages1 = '', $Languages2 = ''
	$languagefiles = _FileListToArray($LanguageDir, '*.ini', 1);Find all files in the folder that end in .ini . These are automatically assumed to a language file
	For $b = 1 To $languagefiles[0];Set Languages into proper format for the combo box
		If $b = 1 Then
			$Languages1 = StringTrimRight($languagefiles[$b], 4)
		ElseIf $b > 1 Then
			$Languages2 &= StringTrimRight($languagefiles[$b], 4)
			If $b < $languagefiles[0] Then $Languages2 &= '|' 
		EndIf
	Next
	
	$LanguageGUI = GUICreate($Text_SetLanguage, 401, 309, -1, -1)
	GUISetBkColor($BackgroundColor)
	$LanguageBox = GUICtrlCreateCombo($Languages1, 8, 8, 385, 25)
	GUICtrlSetData($LanguageBox, $Languages2, $DefaultLanguage)

	$languagefile = $LanguageDir & $DefaultLanguage & ".ini"  ;set default ini file Language Author information will be added into the GUI
	GUICtrlCreateGroup("Language Author", 8, 40, 385, 41)
	$LabAuth = GUICtrlCreateLabel(IniRead($languagefile, 'Info', 'Author', ''), 16, 56, 371, 17)
	GUICtrlCreateGroup("Language Date", 8, 88, 385, 41)
	$LabDate = GUICtrlCreateLabel(IniRead($languagefile, 'Info', 'Date', ''), 16, 104, 371, 17)
	GUICtrlCreateGroup("Language Description", 8, 136, 385, 121)
	$LabDesc = GUICtrlCreateLabel(IniRead($languagefile, 'Info', 'Description', ''), 16, 152, 371, 100)

	$LanguageOk = GUICtrlCreateButton($Text_Ok, 104, 270, 89, 25, 0)
	$LanguageCan = GUICtrlCreateButton($Text_Cancel, 204, 270, 89, 25, 0)
	GUISetState(@SW_SHOW)


	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $LanguageBox;Set author into GUI from selected ini file
				$Language = GUICtrlRead($LanguageBox)
				$languagefile = $LanguageDir & $Language & ".ini" 
				GUICtrlSetData($LabAuth, IniRead($languagefile, 'Info', 'Author', ''))
				GUICtrlSetData($LabDate, IniRead($languagefile, 'Info', 'Date', ''))
				GUICtrlSetData($LabDesc, IniRead($languagefile, 'Info', 'Description', ''))
			Case $LanguageOk ;Read all variables in from the new language file
				$DefaultLanguage = GUICtrlRead($LanguageBox)
				$newlanguagefile = $LanguageDir & $DefaultLanguage & ".ini" 
				$Column_Names_Active = IniRead($newlanguagefile, 'Column_Names', 'Column_Active', 'Active')
				$Column_Names_SSID = IniRead($newlanguagefile, 'Column_Names', 'Column_SSID', 'SSID')
				$Column_Names_BSSID = IniRead($newlanguagefile, 'Column_Names', 'Column_BSSID', 'Mac Address')
				$Column_Names_MANUF = IniRead($newlanguagefile, 'Column_Names', 'Column_Manufacturer', 'Manufacturer')
				$Column_Names_Signal = IniRead($newlanguagefile, 'Column_Names', 'Column_Signal', 'Signal')
				$Column_Names_Authentication = IniRead($newlanguagefile, 'Column_Names', 'Column_Authentication', 'Authentication')
				$Column_Names_Encryption = IniRead($newlanguagefile, 'Column_Names', 'Column_Encryption', 'Encryption')
				$Column_Names_RadioType = IniRead($newlanguagefile, 'Column_Names', 'Column_RadioType', 'Radio Type')
				$Column_Names_Channel = IniRead($newlanguagefile, 'Column_Names', 'Column_Channel', 'Channel')
				$Column_Names_Latitude = IniRead($newlanguagefile, 'Column_Names', 'Column_Latitude', 'Latitude')
				$Column_Names_Longitude = IniRead($newlanguagefile, 'Column_Names', 'Column_Longitude', 'Longitude')
				$Column_Names_BasicTransferRates = IniRead($newlanguagefile, 'Column_Names', 'Column_BasicTransferRates', 'Basic Transfer Rates')
				$Column_Names_OtherTransferRates = IniRead($newlanguagefile, 'Column_Names', 'Column_OtherTransferRates', 'Other Transfer Rates')
				$Column_Names_FirstActive = IniRead($newlanguagefile, 'Column_Names', 'Column_FirstActive', 'First Active')
				$Column_Names_LastActive = IniRead($newlanguagefile, 'Column_Names', 'Column_LastActive', 'Last Active')
				$Column_Names_NetworkType = IniRead($newlanguagefile, 'Column_Names', 'Column_NetworkType', 'Network Type')
				$Column_Names_Label = IniRead($newlanguagefile, 'Column_Names', 'Column_Label', 'Label')
				$Column_Names_SignalHistory = IniRead($newlanguagefile, 'Column_Names', 'Column_SignalHistory', 'Signal History')
				$Column_Names_SignalHistory2 = IniRead($newlanguagefile, 'Column_Names', 'Column_SignalHistory2', 'Signal History 2')
				$SearchWord_SSID = IniRead($newlanguagefile, 'SearchWords', 'SSID', 'SSID')
				$SearchWord_BSSID = IniRead($newlanguagefile, 'SearchWords', 'BSSID', 'BSSID')
				$SearchWord_NetworkType = IniRead($newlanguagefile, 'SearchWords', 'NetworkType', 'Network type')
				$SearchWord_Authentication = IniRead($newlanguagefile, 'SearchWords', 'Authentication', 'Authentication')
				$SearchWord_Encryption = IniRead($newlanguagefile, 'SearchWords', 'Encryption', 'Encryption')
				$SearchWord_Signal = IniRead($newlanguagefile, 'SearchWords', 'Signal', 'Signal')
				$SearchWord_RadioType = IniRead($newlanguagefile, 'SearchWords', 'RadioType', 'Radio Type')
				$SearchWord_Channel = IniRead($newlanguagefile, 'SearchWords', 'Channel', 'Channel')
				$SearchWord_BasicRates = IniRead($newlanguagefile, 'SearchWords', 'BasicRates', 'Basic Rates')
				$SearchWord_OtherRates = IniRead($newlanguagefile, 'SearchWords', 'OtherRates', 'Other Rates')
				$SearchWord_None = IniRead($newlanguagefile, 'SearchWords', 'Open', 'Open')
				$SearchWord_Open = IniRead($newlanguagefile, 'SearchWords', 'None', 'None')
				$Text_Ok = IniRead($newlanguagefile, 'GuiText', 'Ok', '&Ok')
				$Text_Cancel = IniRead($newlanguagefile, 'GuiText', 'Cancel', 'C&ancel')
				$Text_File = IniRead($newlanguagefile, 'GuiText', 'File', '&File')
				$Text_SaveAsTXT = IniRead($newlanguagefile, 'GuiText', 'SaveAsTXT', 'Save As &TXT')
				$Text_ImportFromTXT = IniRead($newlanguagefile, 'GuiText', 'ImportFromTXT', 'Import From &TXT')
				$Text_Exit = IniRead($newlanguagefile, 'GuiText', 'Exit', 'E&xit')
				$Text_Edit = IniRead($newlanguagefile, 'GuiText', 'Edit', 'E&dit')
				$Text_Cut = IniRead($newlanguagefile, 'GuiText', 'Cut', 'Cut')
				$Text_Copy = IniRead($newlanguagefile, 'GuiText', 'Copy', 'Copy')
				$Text_Paste = IniRead($newlanguagefile, 'GuiText', 'Paste', 'Paste')
				$Text_Delete = IniRead($newlanguagefile, 'GuiText', 'Delete', 'Delete')
				$Text_Select = IniRead($newlanguagefile, 'GuiText', 'Select', 'Select')
				$Text_SelectAll = IniRead($newlanguagefile, 'GuiText', 'SelectAll', 'Select All')
				$Text_Options = IniRead($newlanguagefile, 'GuiText', 'Options', '&Options')
				$Text_AutoSort = IniRead($newlanguagefile, 'GuiText', 'AutoSort', 'AutoSort')
				$Text_SortTree = IniRead($newlanguagefile, 'GuiText', 'SortTree', 'Sort Tree  - (slow on big lists)')
				$Text_PlaySound = IniRead($newlanguagefile, 'GuiText', 'PlaySound', 'Play sound on new AP')
				$Text_AddAPsToTop = IniRead($newlanguagefile, 'GuiText', 'AddAPsToTop', 'Add new APs to top')
				$Text_Extra = IniRead($newlanguagefile, 'GuiText', 'Extra', 'Ex&tra')
				$Text_ScanAPs = IniRead($newlanguagefile, 'GuiText', 'ScanAPs', '&Scan APs')
				$Text_StopScanAps = IniRead($newlanguagefile, 'GuiText', 'StopScanAps', '&Stop')
				$Text_UseGPS = IniRead($newlanguagefile, 'GuiText', 'UseGPS', 'Use &GPS')
				$Text_StopGPS = IniRead($newlanguagefile, 'GuiText', 'StopGPS', 'Stop &GPS')
				$Text_Settings = IniRead($newlanguagefile, 'GuiText', 'Settings', 'S&ettings')
				$Text_GpsSettings = IniRead($newlanguagefile, 'GuiText', 'GpsSettings', 'G&PS Settings')
				$Text_SetLanguage = IniRead($newlanguagefile, 'GuiText', 'SetLanguage', 'Set &Language')
				$Text_SetSearchWords = IniRead($newlanguagefile, 'GuiText', 'SetSearchWords', 'Set Search &Words')
				$Text_SetMacLabel = IniRead($newlanguagefile, 'GuiText', 'SetMacLabel', 'Set Labels by Mac')
				$Text_SetMacManu = IniRead($newlanguagefile, 'GuiText', 'SetMacManu', 'Set Manufactures by Mac')
				$Text_Export = IniRead($newlanguagefile, 'GuiText', 'Export', 'Ex&port')
				$Text_ExportToKML = IniRead($newlanguagefile, 'GuiText', 'ExportToKML', 'ExportToKML')
				$Text_ExportToTXT = IniRead($newlanguagefile, 'GuiText', 'ExportToTXT', 'ExportToTXT')
				$Text_PhilsPHPgraph = IniRead($newlanguagefile, 'GuiText', 'PhilsPHPgraph', 'View graph (Phils PHP version)')
				$Text_PhilsMultiPHPgraph = IniRead($newlanguagefile, 'GuiText', 'PhilsMultiPHPgraph', 'Graph all APs (Phils PHP version)')
				$Text_RefreshLoopTime = IniRead($newlanguagefile, 'GuiText', 'RefreshLoopTime', 'Refresh loop time(ms):')
				$Text_ActualLoopTime = IniRead($newlanguagefile, 'GuiText', 'ActualLoopTime', 'Actual loop time:')
				$Text_Longitude = IniRead($newlanguagefile, 'GuiText', 'Longitude', 'Longitude:')
				$Text_Latitude = IniRead($newlanguagefile, 'GuiText', 'Latitude', 'Latitude:')
				$Text_ActiveAPs = IniRead($newlanguagefile, 'GuiText', 'ActiveAPs', 'Active APs:')
				$Text_Graph1 = IniRead($newlanguagefile, 'GuiText', 'Graph1', 'Graph1')
				$Text_Graph2 = IniRead($newlanguagefile, 'GuiText', 'Graph2', 'Graph2')
				$Text_NoGraph = IniRead($newlanguagefile, 'GuiText', 'NoGraph', 'No Graph')
				$Text_Active = IniRead($newlanguagefile, 'GuiText', 'Active', 'Active')
				$Text_Dead = IniRead($newlanguagefile, 'GuiText', 'Dead', 'Dead')
				$Text_AddNewLabel = IniRead($newlanguagefile, 'GuiText', 'AddNewLabel', 'Add New Label To List')
				$Text_RemoveLabel = IniRead($newlanguagefile, 'GuiText', 'RemoveLabel', 'Remove Selected Label From List')
				$Text_EditLabel = IniRead($newlanguagefile, 'GuiText', 'EditLabel', 'Edit Selected Label')
				$Text_AddNewMan = IniRead($newlanguagefile, 'GuiText', 'AddNewMan', 'Add New Manufacturer To List')
				$Text_RemoveMan = IniRead($newlanguagefile, 'GuiText', 'RemoveMan', 'Remove Selected Manufacturer From List')
				$Text_EditMan = IniRead($newlanguagefile, 'GuiText', 'EditMan', 'Edit Selected Manufacturer')
				$Text_NewMac = IniRead($newlanguagefile, 'GuiText', 'NewMac', 'New Mac Address:')
				$Text_NewMan = IniRead($newlanguagefile, 'GuiText', 'NewMan', 'New Manufacturer:')
				$Text_NewLabel = IniRead($newlanguagefile, 'GuiText', 'NewLabel', 'New label:')
				$Text_Save = IniRead($newlanguagefile, 'GuiText', 'Save', 'Save?')
				$Text_SaveQuestion = IniRead($newlanguagefile, 'GuiText', 'SaveQuestion', 'Data has changed. Would you like to save?')
				$Text_GpsDetails = IniRead($newlanguagefile, 'GuiText', 'GpsDetails', 'GPS Details')
				$Text_Quality = IniRead($newlanguagefile, 'GuiText', 'Quality', 'Quality')
				$Text_Time = IniRead($newlanguagefile, 'GuiText', 'Time', 'Time')
				$Text_NumberOfSatalites = IniRead($newlanguagefile, 'GuiText', 'NumberOfSatalites', 'Number of Satalites')
				$Text_HorizontalDilutionPosition = IniRead($newlanguagefile, 'GuiText', 'HorizontalDilutionPosition', 'Horizontal Dilution')
				$Text_Altitude = IniRead($newlanguagefile, 'GuiText', 'Altitude', 'Altitude')
				$Text_HeightOfGeoid = IniRead($newlanguagefile, 'GuiText', 'HeightOfGeoid', 'Height of Geoid')
				$Text_Status = IniRead($newlanguagefile, 'GuiText', 'Status', 'Status')
				$Text_Date = IniRead($newlanguagefile, 'GuiText', 'Date', 'Date')
				$Text_SpeedInKnots = IniRead($newlanguagefile, 'GuiText', 'SpeedInKnots', 'Speed(knots)')
				$Text_SpeedInMPH = IniRead($newlanguagefile, 'GuiText', 'SpeedInMPH', 'Speed(MPH)')
				$Text_SpeedInKmh = IniRead($newlanguagefile, 'GuiText', 'SpeedInKmh', 'Speed(km/h)')
				$Text_TrackAngle = IniRead($newlanguagefile, 'GuiText', 'TrackAngle', 'Track Angle')
				$Text_Close = IniRead($newlanguagefile, 'GuiText', 'Close', 'Track Close')
				_WriteINI()
				MsgBox(0, "Restart Vistumbler", "Please restart Vistumbler for language change to take effect")
				ExitLoop
			Case $LanguageCan
				ExitLoop
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($LanguageGUI)
EndFunc   ;==>_SelectLanguage

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GRAPH/CONTROL POSITION FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------
Func _WinMoved()
	$a = WinGetPos($Vistumbler)
	$winpos_old = $winpos
	$winpos = $a[0] & '-' & $a[1] & '-' & $a[2] & '-' & $a[3]
	If $winpos_old <> $winpos Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc   ;==>_WinMoved

Func _SetControlSizes()
	$a = WinGetPos($Vistumbler)
	WinMove($DataChild, "", 0, 60, $a[2] - 10, $a[3] - 115)
	$b = WinGetPos($DataChild) ;get child window size
	$sizes = $a[0] & '-' & $a[1] & '-' & $a[2] & '-' & $a[3] & '-' & $b[0] & '-' & $b[1] & '-' & $b[2] & '-' & $b[3]
	If $sizes <> $sizes_old Or $Graph <> $Graph_old Or $Redraw = 1 Then
		If $Graph <> 0 Then
			$Graphic_left = ($b[2] * 0.01)
			$Graphic_width = Round(($b[2] * 0.99) - $Graphic_left)
			$Graphic_top = ($b[3] * 0.01)
			$Graphic_height = Round(($b[3] * 0.64) - $Graphic_top)
			
			$ListviewAPs_left = ($b[2] * 0.01)
			$ListviewAPs_width = Round(($b[2] * 0.99) - $ListviewAPs_left)
			$ListviewAPs_top = ($b[3] * 0.65)
			$ListviewAPs_height = Round(($b[3] * 0.99) - $ListviewAPs_top)

			GUICtrlSetState($TreeviewAPs, $GUI_HIDE)
			WinMove($GraphicGUI, "", $Graphic_left, $Graphic_top + 60, $Graphic_width, $Graphic_height)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
			
		Else
			$TreeviewAPs_left = ($b[2] * 0.01)
			$TreeviewAPs_width = ($b[2] * 0.20) - $TreeviewAPs_left
			$TreeviewAPs_top = ($b[3] * 0.01)
			$TreeviewAPs_height = ($b[3] * 0.99) - $TreeviewAPs_top
			
			$ListviewAPs_left = ($b[2] * 0.20) + 1
			$ListviewAPs_width = ($b[2] * 0.99) - $ListviewAPs_left
			$ListviewAPs_top = ($b[3] * 0.01)
			$ListviewAPs_height = ($b[3] * 0.99) - $ListviewAPs_top
			
			GUICtrlSetState($TreeviewAPs, $GUI_SHOW)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			GUICtrlSetPos($TreeviewAPs, $TreeviewAPs_left, $TreeviewAPs_top, $TreeviewAPs_width, $TreeviewAPs_height)
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
		EndIf
		$sizes_old = $sizes
		$Graph_old = $Graph
	EndIf
EndFunc   ;==>_SetControlSizes

Func _GraphApSignal()
	If $Graph <> 0 Then; If the graph tab is selected, run graph script
		$Selected = _GUICtrlListView_GetNextItem ($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected
		If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
			$line = _GUICtrlListView_GetItemText ($ListviewAPs, $Selected, $column_Line)
			$data = ''
			For $finddata = 1 To $DataArray_Line[0]
				If $DataArray_Line[$finddata] = $line Then
					$data = $DataArray_SigHist[$finddata]
					ExitLoop
				EndIf
			Next
			If $data <> $data_old Or $sizes <> $sizes_old Or $Redraw = 1 Then ; if graph data changed, map new data
				$base_right = $Graphic_width - 1
				$base_left = 0
				$base_top = 0
				$base_bottom = $Graphic_height - 1
				$base_x = $base_right - $base_left
				$base_y = $base_bottom - $base_top

				$max_graph_points = 125
				$data_old = $data
				$sizes_old = $sizes
				$splitdata = StringSplit($data, '-');Split signals into an array
				
				If IsArray($splitdata) Then
					If $Selected <> $LastSelected Or $Redraw = 1 Then
						$o_old = 0
						$Redraw = 1
						For $r = 1 To $Graphic_height
							_SelectColor($GraphBack)
							_DrawLine($base_left, $r, $base_right, $r)
						Next
						$LastSelected = $Selected
						
						_SelectColor($GraphGrid)
						_DrawLine($base_left, $base_top, $base_left, $base_bottom)
						_DrawLine($base_right, $base_top, $base_right, $base_bottom)
						_DrawLine($base_left, $base_bottom, $base_right, $base_bottom)
						_DrawLine($base_left, $base_top, $base_right, $base_top)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * ($base_y / 100)
							_DrawLine($base_right, $subtract_value, $base_left, $subtract_value)
						Next
					EndIf
					
					If $Graph = 1 Then
						If $splitdata[0] > $max_graph_points Then ; If the array is grater that the max number of ports, set array size to the max size, else use the full size of the array
							$start = $splitdata[0] - $max_graph_points
							$arrayend = $splitdata[0]
							$arraylen = $max_graph_points
						Else
							$start = 1
							$arrayend = $splitdata[0]
							$arraylen = $splitdata[0]
						EndIf
						$base_x_add_value = ($base_x / ($arraylen - 2)); Set disance between points
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						
						
						;############### Start Mapping Access Point signal Data ###############
						_SelectColor($red)
						$base_add = $base_left
						For $o = $start To ($arrayend - 2)
							$x1 = $base_left + ($base_add - $base_x_add_value)
							$x2 = $base_left + $base_add
							$x3 = $base_left + ($base_add + $base_x_add_value)
							$x4 = $base_left + ($base_add + ($base_x_add_value * 2))
							$y1 = ($base_bottom - ($splitdata[$o - 1] * $base_y_add_value))
							$y2 = $base_bottom - ($splitdata[$o] * $base_y_add_value)
							$y3 = $base_bottom - ($splitdata[$o + 1] * $base_y_add_value)
							$y4 = $base_bottom - ($splitdata[$o + 2] * $base_y_add_value)
							$y_high = $y1
							If $y2 > $y_high Then $y_high = $y2
							If $y3 > $y_high Then $y_high = $y3
							If $y4 > $y_high Then $y_high = $y4
							$y_low = $y1
							If $y2 < $y_low Then $y_low = $y2
							If $y3 < $y_low Then $y_low = $y3
							If $y4 < $y_low Then $y_low = $y4
							
							;MsgBox(0, '', $x1)
							_SelectColor($GraphBack)
							For $rl = $x1 To $x4
								_DrawLine($rl, $y_high + 2, $rl, $y_low - 2)
							Next
							
							_SelectColor($GraphGrid)
							For $drawline = 1 To 10
								$subtract_value = (($drawline * 10) * $base_y_add_value)
								_DrawLine($x1, $subtract_value, $x4, $subtract_value)
							Next
							
							_DrawLine($base_right, $base_top, $base_right, $base_bottom)
							_DrawLine($base_left, $base_top, $base_left, $base_bottom)
							_DrawLine($base_left, $base_top, $base_right, $base_top)
							
							_SelectColor($red)
							_DrawDot($x1, $y1)
							_DrawLine($x1, $y1, $x2, $y2);Draw line
							_DrawDot($x2, $y2)
							_DrawLine($x2, $y2, $x3, $y3);Draw line
							_DrawDot($x3, $y3)
							_DrawLine($x3, $y3, $x4, $y4);Draw line
							_DrawDot($x4, $y4)
							$base_add += $base_x_add_value
						Next
						;############### End Mapping Access Point signal Data ###############
					ElseIf $Graph = 2 Then
						If $splitdata[0] > $base_x Then
							$start = $splitdata[0] - $base_x
							$arraylen = $splitdata[0]
							;_ArrayDisplay($splitdata, $start)
						Else
							$start = 1
							$arraylen = $splitdata[0]
						EndIf
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						
						$base_add = $base_left + 1
						$base_x_add_value = 1
						
						For $o = $start To $arraylen
							If $o < $arraylen And $o <> $start And $Redraw <> 1 Then
								If $splitdata[$o] <> $splitdata[$o - 1] And $start <> 1 Then
									_SelectColor($red)
									_DrawLine(($base_left + $base_add), $base_bottom, ($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value))
									_SelectColor($GraphBack)
									_DrawLine(($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value), ($base_left + $base_add), $base_top)
									_SelectColor($GraphGrid)
									For $drawline = 1 To 10
										$subtract_value = ($drawline * 10) * $base_y_add_value
										_DrawLine(($base_left + $base_add), $subtract_value, ($base_left + $base_add) + 1, $subtract_value)
									Next
								ElseIf $o_old < $o And $start = 1 Then
									_SelectColor($red)
									_DrawLine(($base_left + $base_add), $base_bottom, ($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value))
									_SelectColor($GraphBack)
									_DrawLine(($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value), ($base_left + $base_add), $base_top)
									_SelectColor($GraphGrid)
									For $drawline = 1 To 10
										$subtract_value = ($drawline * 10) * $base_y_add_value
										_DrawLine(($base_left + $base_add), $subtract_value, ($base_left + $base_add) + 1, $subtract_value)
									Next
									$o_old = $o
								EndIf
							ElseIf $o = $start Or $o = $arraylen Or $Redraw = 1 Then
								_SelectColor($red)
								_DrawLine(($base_left + $base_add), $base_bottom, ($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value))
								_SelectColor($GraphBack)
								_DrawLine(($base_left + $base_add), $base_bottom - ($splitdata[$o] * $base_y_add_value), ($base_left + $base_add), $base_top)
								_SelectColor($GraphGrid)
								For $drawline = 1 To 10
									$subtract_value = ($drawline * 10) * $base_y_add_value
									_DrawLine(($base_left + $base_add), $subtract_value, ($base_left + $base_add) + 1, $subtract_value)
								Next
							EndIf
							$base_add += $base_x_add_value
						Next
						_DrawLine($base_right, $base_top, $base_right, $base_bottom)
						_DrawLine($base_left, $base_top, $base_left, $base_bottom)
						_DrawLine($base_left, $base_top, $base_right, $base_top)
					EndIf
				EndIf
				$Redraw = 0
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GraphApSignal

Func _ResetSizes()
	$ResetSizes = 1
EndFunc   ;==>_ResetSizes

;-------------------------------------------------------------------------------------------------------------------------------
;Graph API Functions - By neogia - http://www.autoitscript.com/forum/index.php?showtopic=24621&hl=GUICtrlSetGraphic+windows+api
;Used in place of autoit Graphic function to remove flicker when the graph gets redraw (it is slower though :-( )
;-------------------------------------------------------------------------------------------------------------------------------
Func _DrawDot($x, $y)
	_DrawLine($x - 1, $y - 1, $x + 1, $y - 1)
	_DrawLine($x - 1, $y, $x + 1, $y)
	_DrawLine($x - 1, $y + 1, $x + 1, $y + 1)
EndFunc   ;==>_DrawDot

Func _DrawingStartUp($GUI)
	Global $gdi_dll = DllOpen("gdi32.dll")
	Global $user32_dll = DllOpen("user32.dll")
	Global $hDC = DllCall("user32.dll", "int", "GetDC", "hwnd", $GUI)
	$hDC = $hDC[0]
EndFunc   ;==>_DrawingStartUp

Func _DrawingShutDown($GUI)
	DllCall($user32_dll, "int", "ReleaseDC", "int", $hDC, "hwnd", $GUI)
	DllClose($gdi_dll)
	DllClose($user32_dll)
EndFunc   ;==>_DrawingShutDown

Func _CreateColor($r, $g, $b)
	$hPen = DllCall($gdi_dll, "hwnd", "CreatePen", "int", "0", "int", "0", "hwnd", "0x00" & Hex($b, 2) & Hex($g, 2) & Hex($r, 2))
	Return $hPen[0]
EndFunc   ;==>_CreateColor

Func _SelectColor($hPen)
	DllCall($gdi_dll, "hwnd", "SelectObject", "hwnd", $hDC, "hwnd", $hPen)
EndFunc   ;==>_SelectColor

Func _DrawLine($x0, $y0, $x1, $y1)
	DllCall($gdi_dll, "int", "MoveToEx", "hwnd", $hDC, "int", $x0, "int", $y0, "ptr", 0)
	DllCall($gdi_dll, "int", "LineTo", "hwnd", $hDC, "int", $x1, "int", $y1)
EndFunc   ;==>_DrawLine

;-------------------------------
;Graph API functions by ACalcutt
;-------------------------------

Func _DeleteObject($hPen)
	DllCall($gdi_dll, "int", "DeleteObject", "int", $hPen)
EndFunc   ;==>_DeleteObject

Func _CreatePens()
	$GraphBack = _CreateColor(215, 228, 242)
	$black = _CreateColor(0, 0, 0)
	$red = _CreateColor(255, 0, 0)
	$GraphGrid = _CreateColor(0, 0, 255)
EndFunc   ;==>_CreatePens

Func _DeletePens()
	_DeleteObject($GraphBack)
	_DeleteObject($black)
	_DeleteObject($red)
	_DeleteObject($GraphGrid)
EndFunc   ;==>_DeletePens

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SAVE AND OPEN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ViewInPhilsPHP()
	$Selected = _GUICtrlListView_GetNextItem ($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected
	If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
		
		$found = -1
		For $row = 1 To $DataArray_Row[0]
			If $DataArray_Row[$row] = $Selected Then
				$found = $row
				ExitLoop
			EndIf
		Next
		
		If $found <> -1 Then
			$psarray = StringSplit($DataArray_SigHist[$found], '-')
			If @error = 1 Then
				MsgBox(0, "Error", "No signal history found, chech to make sure your netsh search words are correct")
			Else
				For $pg = 1 To $psarray[0];reverse signal history
					If $pg = 1 Then
						$pgsigdata = $psarray[$pg]
					Else
						$pgsigdata = $psarray[$pg] & '-' & $pgsigdata
					EndIf
				Next
				$url_root = "http://www.randomintervals.com/wifi/?" 
				$url_data = "SSID=" & $DataArray_SSID[$found] & "&Mac=" & $DataArray_BSSID[$found] & "&Manuf=" & $DataArray_Manu[$found] & "&Auth=" & $DataArray_Auth[$found] & "&Encry=" & $DataArray_Encr[$found] & "&radio=" & $DataArray_Rad[$found] & "&Chn=" & $DataArray_Chan[$found] & "&Lat=" & $DataArray_Lat[$found] & "&Long=" & $DataArray_Lon[$found] & "&BTx=" & $DataArray_BtX[$found] & "&OTx=" & $DataArray_OtX[$found] & "&FA=" & $DataArray_FirstTime[$found] & "&LU=" & $DataArray_LastTime[$found] & "&NT=" & $DataArray_NetType[$found] & "&Label=" & $DataArray_Label[$found] & "&Sig=" & $pgsigdata
				$url_full = $url_root & $url_data
				$url_trimmed = StringTrimRight($url_full, (StringLen($url_full) - 2048)) ;trim sting to internet explorer max url lenth
				$url_trimmed2 = StringTrimRight($url_trimmed, (StringLen($url_trimmed) - StringInStr($url_trimmed, "-", 1, -1)) + 1);find - that marks the last full data and get rid of the rest
				Run("RunDll32.exe url.dll,FileProtocolHandler " & $url_trimmed2);open url with rundll 32
			EndIf
		EndIf
	Else
		MsgBox(0, "Error", "You did not select an access point")
	EndIf
EndFunc   ;==>_ViewInPhilsPHP

Func _ViewMultiInPhilsPHP()
	DirCreate($SaveDir)
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$File = FileSaveDialog("Output File", $SaveDir, 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		FileDelete($File)
		For $save = 1 To $DataArray_BSSID[0]
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save & ' / ' & $DataArray_BSSID[0])
			FileWriteLine($File, $DataArray_SSID[$save] & '|' & $DataArray_BSSID[$save] & '|' & $DataArray_Manu[$save] & '|' & $DataArray_Sig[$save] & '|' & $DataArray_Auth[$save] & '|' & $DataArray_Encr[$save] & '|' & $DataArray_Rad[$save] & '|' & $DataArray_Chan[$save] & '|' & $DataArray_Lat[$save] & '|' & $DataArray_Lon[$save] & '|' & $DataArray_BtX[$save] & '|' & $DataArray_OtX[$save] & '|' & $DataArray_FirstTime[$save] & '|' & $DataArray_LastTime[$save] & '|' & $DataArray_NetType[$save] & '|' & $DataArray_Label[$save] & '|' & $DataArray_SigHist[$save])
		Next
		$url_root = "http://www.randomintervals.com/test/wifi/start.php?" 
		$url_data = $url_root & "File=" & $File
		Run("RunDll32.exe url.dll,FileProtocolHandler " & $url_data);open url with rundll 32
		GUICtrlSetData($msgdisplay, '')
		$newdata = 0
	EndIf
EndFunc   ;==>_ViewMultiInPhilsPHP

Func _ExportData()
	DirCreate($SaveDir)
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$File = FileSaveDialog("Output File", $SaveDir, 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		FileDelete($File)
		For $save = 1 To $DataArray_BSSID[0]
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save & ' / ' & $DataArray_BSSID[0])
			FileWriteLine($File, $DataArray_SSID[$save] & '|' & $DataArray_BSSID[$save] & '|' & $DataArray_Manu[$save] & '|' & $DataArray_Sig[$save] & '|' & $DataArray_Auth[$save] & '|' & $DataArray_Encr[$save] & '|' & $DataArray_Rad[$save] & '|' & $DataArray_Chan[$save] & '|' & $DataArray_Lat[$save] & '|' & $DataArray_Lon[$save] & '|' & $DataArray_BtX[$save] & '|' & $DataArray_OtX[$save] & '|' & $DataArray_FirstTime[$save] & '|' & $DataArray_LastTime[$save] & '|' & $DataArray_NetType[$save] & '|' & $DataArray_Label[$save] & '|' & $DataArray_SigHist[$save])
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $File & '"')
		GUICtrlSetData($msgdisplay, '')
		$newdata = 0
	EndIf
EndFunc   ;==>_ExportData

Func LoadList()
	DirCreate($SaveDir)
	$File = FileOpenDialog("Import File", $SaveDir, 'Text (*.txt)')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		_FileReadToArray($File, $OpenArray)
		$NewApNumber = 0
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				;MsgBox(0, '', $loadlist[0])
				Dim $SSID = '', $BSSID = '', $MANUF = '', $Signal = '', $Authentication = '', $Encryption = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '', $NetworkType = '';Clear Variables
				If $loadlist[0] = 17 Or $loadlist[0] = 18 Then
					$SSID = StringStripWS($loadlist[1], 3)
					$BSSID = StringStripWS($loadlist[2], 3)
					If $loadlist[3] <> 'Unknown'  Then $MANUF = StringStripWS($loadlist[3], 3)
					;$Signal = StringStripWS($loadlist[4], 3)
					$Authentication = StringStripWS($loadlist[5], 3)
					$Encryption = StringStripWS($loadlist[6], 3)
					$RadioType = StringStripWS($loadlist[7], 3)
					$Channel = StringStripWS($loadlist[8], 3)
					$LoadLatitude = StringStripWS($loadlist[9], 3)
					$LoadLongitude = StringStripWS($loadlist[10], 3)
					$BasicTransferRates = StringStripWS($loadlist[11], 3)
					$OtherTransferRates = StringStripWS($loadlist[12], 3)
					$FirstActive = StringStripWS($loadlist[13], 3)
					$LastActive = StringStripWS($loadlist[14], 3)
					$NetworkType = StringStripWS($loadlist[15], 3)
					;$LABEL = StringStripWS($loadlist[16], 3)
					$SignalHistory = StringStripWS($loadlist[17], 3)
					If $loadlist[0] = 18 Then $SignalHistory &= StringStripWS($loadlist[18], 3)
					If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
						$arraysearch = -1
						
						For $findloop = 1 To $DataArray_BSSID[0]
							If $DataArray_BSSID[$findloop] = $BSSID Then
								If $DataArray_SSID[$findloop] = $SSID And $DataArray_Auth[$findloop] = $Authentication And $DataArray_Encr[$findloop] = $Encryption And $DataArray_Chan[$findloop] = $Channel And $DataArray_Rad[$findloop] = $RadioType Then
									$arraysearch = $DataArray_Row[$findloop];$DataArray_Row[$findloop]
									ExitLoop
								EndIf
							EndIf
						Next
						
						If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
							$NewApNumber += 1
							$new = _GUICtrlListView_InsertItem ($ListviewAPs, -1, '')
							$StripedBSSID = StringReplace($BSSID, ':', '')
							$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
							$LABEL = _SetLables($StripedBSSID)
							_ListViewAdd($new, $DataArray_BSSID[0] + $NewApNumber, $Text_Dead, $MANUF, '0%', $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $LoadLatitude, $LoadLongitude, $BasicTransferRates, $OtherTransferRates, $FirstActive, $LastActive, $NetworkType, $LABEL)
							;Add AP into the array
							
							$TreePosString = _TreeViewAdd($SSID, $BSSID, $Channel, $NetworkType, $Encryption, $RadioType, $Authentication, $BasicTransferRates, $OtherTransferRates, $LABEL)
							$TreePos = StringSplit($TreePosString, '|')

							;Add AP into the array
							_ArrayAdd($DataArray_Line, $DataArray_BSSID[0] + $NewApNumber)
							_ArrayAdd($DataArray_Active, "Dead")
							_ArrayAdd($DataArray_BSSID, $BSSID)
							_ArrayAdd($DataArray_SSID, $SSID)
							_ArrayAdd($DataArray_Auth, $Authentication)
							_ArrayAdd($DataArray_Encr, $Encryption)
							_ArrayAdd($DataArray_Sig, "0%")
							_ArrayAdd($DataArray_Chan, $Channel)
							_ArrayAdd($DataArray_Rad, $RadioType)
							_ArrayAdd($DataArray_Lon, $LoadLongitude)
							_ArrayAdd($DataArray_Lat, $LoadLatitude)
							_ArrayAdd($DataArray_BtX, $BasicTransferRates)
							_ArrayAdd($DataArray_OtX, $OtherTransferRates)
							_ArrayAdd($DataArray_NetType, $NetworkType)
							_ArrayAdd($DataArray_FirstTime, $FirstActive)
							_ArrayAdd($DataArray_LastTime, $LastActive)
							_ArrayAdd($DataArray_SigHist, $SignalHistory)
							_ArrayAdd($DataArray_Manu, $MANUF)
							_ArrayAdd($DataArray_Label, $LABEL)
							_ArrayAdd($DataArray_Row, $new)
							_ArrayAdd($DataArray_TreeViewSubChannel, $TreePos[1])
							_ArrayAdd($DataArray_TreeViewSubSSID, $TreePos[2])
							_ArrayAdd($DataArray_TreeViewSubEncr, $TreePos[3])
							_ArrayAdd($DataArray_TreeViewSubAuth, $TreePos[4])
							_ArrayAdd($DataArray_TreeViewSubNetType, $TreePos[5])
							
						Else
							Dim $MANUF = '', $LABEL = ''
							$addposition = $DataArray_Row[$arraysearch]
							$CurrentSignal = $DataArray_SigHist[$arraysearch] & '-' & $SignalHistory

							If StringTrimLeft($newlat, 2) = '0.0000000'  Or $newlat = '' Or StringTrimLeft($newlon, 2) = '0.0000000'  Or $newlon = '' Or StringTrimLeft($DataArray_Lat[$arraysearch], 2) <> '0.0000000'  Then
								Dim $newlat = '', $newlon = ''
							EndIf
							
							$StripedBSSID = StringReplace($BSSID, ':', '')
							If $DataArray_Manu[$arraysearch] = '' Then $MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
							If $DataArray_Label[$arraysearch] = '' Then $LABEL = _SetLables($StripedBSSID)
							
							_ListViewAdd($addposition, '', $Text_Dead, $MANUF, '', '', '', '', '', '', '', $LoadLongitude, $LoadLatitude, '', '', '', $FirstActive, $LastActive, $LABEL)
							
							$DataArray_Lon[$arraysearch] = $Longitude
							$DataArray_Lat[$arraysearch] = $Latitude
							$DataArray_FirstTime[$arraysearch] = $FirstActive
							$DataArray_FirstTime[$arraysearch] = $LastActive
							$DataArray_SigHist[$arraysearch] = $CurrentSignal
							$DataArray_Manu[$arraysearch] = $MANUF
							$DataArray_Label[$arraysearch] = $LABEL
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		_SetDataArraySizes()
		_FixLineNumbers()
		MsgBox(0, 'Done', 'Load of file: "' & $File & '" complete')
		GUICtrlSetData($msgdisplay, "")
	EndIf
	$newdata = 1
	$ResetMacLabel = 1
	$ResetManLabel = 1
EndFunc   ;==>LoadList

Func SaveToKML()
	DirCreate($SaveDir)
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$kml = FileSaveDialog("Google Earth Output File", $SaveDir, 'Google Earth (*.kml)', '', $timestamp & '.kml')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml' 
		FileDelete($kml)
		$File = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>' & $Script_Name & ' - By ' & $Script_Author & '</description>' & @CRLF _
				 & '<name>' & $Script_Name & ' ' & $version & '</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		;& '<href>' & $FilesDir & 'wap-secure.png</href>' & @CRLF _;image from EarthStubler
		;& '<href>' & $FilesDir & 'wap-open.png</href>' & @CRLF _;image from EarthStubler
		$FoundApWithGps = 0
		For $i = 1 To $DataArray_BSSID[0]
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i & ' / ' & $DataArray_BSSID[0])
			If StringReplace(StringReplace($DataArray_Lat[$i], 'N ', ''), 'S ', '') <> '0.0000000'  And StringReplace(StringReplace($DataArray_Lon[$i], 'E ', ''), 'W ', '') <> '0.0000000'  Then
				$File &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & $DataArray_SSID[$i] & '<br /><b>BSSID: </b>' & $DataArray_BSSID[$i] & '<br /><b>Network Type: </b>' & $DataArray_NetType[$i] & '<br /><b>Radio Type: </b>' & $DataArray_Rad[$i] & '<br /><b>Channel: </b>' & $DataArray_Chan[$i] & '<br /><b>Authentication: </b>' & $DataArray_Auth[$i] & '<br /><b>Encryption: </b>' & $DataArray_Encr[$i] & '<br /><b>Basic Rates: </b>' & $DataArray_BtX[$i] & '<br /><b>Other Rates: </b>' & $DataArray_OtX[$i] & '<br /><b>First Seen: </b>' & $DataArray_FirstTime[$i] & '<br /><b>Last Seen: </b>' & $DataArray_LastTime[$i] & '<br /><b>Latitude: </b>' & $DataArray_Lat[$i] & '<br /><b>Longitude: </b>' & $DataArray_Lon[$i] & '<br /><b>Manufacturer: </b>' & $DataArray_Manu[$i] & '<br /><b>Signal History: </b>' & $DataArray_SigHist[$i] & '<br />]]></description>' 

				If $DataArray_Auth[$i] = $SearchWord_None And $DataArray_Encr[$i] = $SearchWord_Open Then
					$File &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$File &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$File &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace($DataArray_Lon[$i], 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace($DataArray_Lat[$i], 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
				$FoundApWithGps = 1
			EndIf
		Next
		
		$File &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF
		
		If $FoundApWithGps = 1 Then
			FileWrite($kml, $File)
			MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
			GUICtrlSetData($msgdisplay, '')
		Else
			MsgBox(0, 'Done', 'No Access Points found with GPS coordinates. No file has been saved')
			GUICtrlSetData($msgdisplay, '')
		EndIf
	EndIf
EndFunc   ;==>SaveToKML

Func _WriteINI()
	;Get new order of columns to write back to INI
	$currentcolumn = StringSplit(_GUICtrlListView_GetColumnOrder ($ListviewAPs), '|')
	;_ArrayDisplay($currentcolumn)
	For $c = 1 To $currentcolumn[0]
		If $column_Line = $currentcolumn[$c] Then
			$save_column_Line = $c - 1
		ElseIf $column_Active = $currentcolumn[$c] Then
			$save_column_Active = $c - 1
		ElseIf $column_SSID = $currentcolumn[$c] Then
			$save_column_SSID = $c - 1
		ElseIf $column_BSSID = $currentcolumn[$c] Then
			$save_column_BSSID = $c - 1
		ElseIf $column_MANUF = $currentcolumn[$c] Then
			$save_column_MANUF = $c - 1
		ElseIf $column_Signal = $currentcolumn[$c] Then
			$save_column_Signal = $c - 1
		ElseIf $column_Authentication = $currentcolumn[$c] Then
			$save_column_Authentication = $c - 1
		ElseIf $column_Encryption = $currentcolumn[$c] Then
			$save_column_Encryption = $c - 1
		ElseIf $column_RadioType = $currentcolumn[$c] Then
			$save_column_RadioType = $c - 1
		ElseIf $column_Channel = $currentcolumn[$c] Then
			$save_column_Channel = $c - 1
		ElseIf $column_Latitude = $currentcolumn[$c] Then
			$save_column_Latitude = $c - 1
		ElseIf $column_Longitude = $currentcolumn[$c] Then
			$save_column_Longitude = $c - 1
		ElseIf $column_BasicTransferRates = $currentcolumn[$c] Then
			$save_column_BasicTransferRates = $c - 1
		ElseIf $column_OtherTransferRates = $currentcolumn[$c] Then
			$save_column_OtherTransferRates = $c - 1
		ElseIf $column_FirstActive = $currentcolumn[$c] Then
			$save_column_FirstActive = $c - 1
		ElseIf $column_LastActive = $currentcolumn[$c] Then
			$save_column_LastActive = $c - 1
		ElseIf $column_NetworkType = $currentcolumn[$c] Then
			$save_column_NetworkType = $c - 1
		ElseIf $column_Label = $currentcolumn[$c] Then
			$save_column_Label = $c - 1
		EndIf
	Next

	;write ini settings
	IniWrite($settings, "Vistumbler", "Netsh_exe", $netsh)
	IniWrite($settings, "Vistumbler", "ComPort", $ComPort)
	IniWrite($settings, "Vistumbler", "Baud", $BAUD)
	IniWrite($settings, "Vistumbler", "Sleeptime", GUICtrlRead($sleeptime))
	IniWrite($settings, "Vistumbler", "AutoSortTime", $SortTime)
	IniWrite($settings, "Vistumbler", "SortCombo", $SortBy)
	IniWrite($settings, "Vistumbler", "AscDecDefault", $SortDirection)
	IniWrite($settings, "Vistumbler", "AutoSort", $AutoSort)
	IniWrite($settings, "Vistumbler", "NewAP_Sound", $new_AP_sound)
	IniWrite($settings, "Vistumbler", "Error_Sound", $error_sound)
	IniWrite($settings, "Vistumbler", "NewApPosistion", $AddDirection)
	IniWrite($settings, "Vistumbler", "Language", $DefaultLanguage)
	IniWrite($settings, "Vistumbler", "UseNetcomm", $UseNetcomm)
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		IniWrite($settings, "Vistumbler", "PlaySoundOnNewAP", 1)
	Else
		IniWrite($settings, "Vistumbler", "PlaySoundOnNewAP", 0)
	EndIf
	
	IniWrite($settings, "Columns", "Column_Line", $save_column_Line)
	IniWrite($settings, "Columns", "Column_Active", $save_column_Active)
	IniWrite($settings, "Columns", "Column_SSID", $save_column_SSID)
	IniWrite($settings, "Columns", "Column_BSSID", $save_column_BSSID)
	IniWrite($settings, "Columns", "Column_Manufacturer", $save_column_MANUF)
	IniWrite($settings, "Columns", "Column_Signal", $save_column_Signal)
	IniWrite($settings, "Columns", "Column_Authentication", $save_column_Authentication)
	IniWrite($settings, "Columns", "Column_Encryption", $save_column_Encryption)
	IniWrite($settings, "Columns", "Column_RadioType", $save_column_RadioType)
	IniWrite($settings, "Columns", "Column_Channel", $save_column_Channel)
	IniWrite($settings, "Columns", "Column_Latitude", $save_column_Latitude)
	IniWrite($settings, "Columns", "Column_Longitude", $save_column_Longitude)
	IniWrite($settings, "Columns", "Column_BasicTransferRates", $save_column_BasicTransferRates)
	IniWrite($settings, "Columns", "Column_OtherTransferRates", $save_column_OtherTransferRates)
	IniWrite($settings, "Columns", "Column_FirstActive", $save_column_FirstActive)
	IniWrite($settings, "Columns", "Column_LastActive", $save_column_LastActive)
	IniWrite($settings, "Columns", "Column_NetworkType", $save_column_NetworkType)
	IniWrite($settings, "Columns", "Column_Label", $save_column_Label)
	
	IniWrite($settings, "Column_Width", "Column_Line", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Line - 0))
	IniWrite($settings, "Column_Width", "Column_Active", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Active - 0))
	IniWrite($settings, "Column_Width", "Column_SSID", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_SSID - 0))
	IniWrite($settings, "Column_Width", "Column_BSSID", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_BSSID - 0))
	IniWrite($settings, "Column_Width", "Column_Manufacturer", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_MANUF - 0))
	IniWrite($settings, "Column_Width", "Column_Signal", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Signal - 0))
	IniWrite($settings, "Column_Width", "Column_Authentication", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Authentication - 0))
	IniWrite($settings, "Column_Width", "Column_Encryption", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Encryption - 0))
	IniWrite($settings, "Column_Width", "Column_RadioType", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_RadioType - 0))
	IniWrite($settings, "Column_Width", "Column_Channel", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Channel - 0))
	IniWrite($settings, "Column_Width", "Column_Latitude", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Latitude - 0))
	IniWrite($settings, "Column_Width", "Column_Longitude", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Longitude - 0))
	IniWrite($settings, "Column_Width", "Column_BasicTransferRates", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_BasicTransferRates - 0))
	IniWrite($settings, "Column_Width", "Column_OtherTransferRates", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_OtherTransferRates - 0))
	IniWrite($settings, "Column_Width", "Column_FirstActive", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_FirstActive - 0))
	IniWrite($settings, "Column_Width", "Column_LastActive", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_LastActive - 0))
	IniWrite($settings, "Column_Width", "Column_NetworkType", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_NetworkType - 0))
	IniWrite($settings, "Column_Width", "Column_Label", _GUICtrlListView_GetColumnWidth ($ListviewAPs, $column_Label - 0))

	IniWrite($settings, "Column_Names", "Column_Line", $Column_Names_Line)
	IniWrite($settings, "Column_Names", "Column_Active", $Column_Names_Active)
	IniWrite($settings, "Column_Names", "Column_SSID", $Column_Names_SSID)
	IniWrite($settings, "Column_Names", "Column_BSSID", $Column_Names_BSSID)
	IniWrite($settings, "Column_Names", "Column_Manufacturer", $Column_Names_MANUF)
	IniWrite($settings, "Column_Names", "Column_Signal", $Column_Names_Signal)
	IniWrite($settings, "Column_Names", "Column_Authentication", $Column_Names_Authentication)
	IniWrite($settings, "Column_Names", "Column_Encryption", $Column_Names_Encryption)
	IniWrite($settings, "Column_Names", "Column_RadioType", $Column_Names_RadioType)
	IniWrite($settings, "Column_Names", "Column_Channel", $Column_Names_Channel)
	IniWrite($settings, "Column_Names", "Column_Latitude", $Column_Names_Latitude)
	IniWrite($settings, "Column_Names", "Column_Longitude", $Column_Names_Longitude)
	IniWrite($settings, "Column_Names", "Column_BasicTransferRates", $Column_Names_BasicTransferRates)
	IniWrite($settings, "Column_Names", "Column_OtherTransferRates", $Column_Names_OtherTransferRates)
	IniWrite($settings, "Column_Names", "Column_FirstActive", $Column_Names_FirstActive)
	IniWrite($settings, "Column_Names", "Column_LastActive", $Column_Names_LastActive)
	IniWrite($settings, "Column_Names", "Column_NetworkType", $Column_Names_NetworkType)
	IniWrite($settings, "Column_Names", "Column_Label", $Column_Names_Label)
	
	IniWrite($settings, "SearchWords", "SSID", $SearchWord_SSID)
	IniWrite($settings, "SearchWords", "BSSID", $SearchWord_BSSID)
	IniWrite($settings, "SearchWords", "NetworkType", $SearchWord_NetworkType)
	IniWrite($settings, "SearchWords", "Authentication", $SearchWord_Authentication)
	IniWrite($settings, "SearchWords", "Encryption", $SearchWord_Encryption)
	IniWrite($settings, "SearchWords", "Signal", $SearchWord_Signal)
	IniWrite($settings, "SearchWords", "RadioType", $SearchWord_RadioType)
	IniWrite($settings, "SearchWords", "Channel", $SearchWord_Channel)
	IniWrite($settings, "SearchWords", "BasicRates", $SearchWord_BasicRates)
	IniWrite($settings, "SearchWords", "OtherRates", $SearchWord_OtherRates)
	IniWrite($settings, "SearchWords", "Open", $SearchWord_Open)
	IniWrite($settings, "SearchWords", "None", $SearchWord_None)
	
	IniWrite($settings, "GuiText", "Ok", $Text_Ok)
	IniWrite($settings, "GuiText", "Cancel", $Text_Cancel)
	IniWrite($settings, "GuiText", "File", $Text_File)
	IniWrite($settings, "GuiText", "SaveAsTXT", $Text_SaveAsTXT)
	IniWrite($settings, "GuiText", "ImportFromTXT", $Text_ImportFromTXT)
	IniWrite($settings, "GuiText", "Exit", $Text_Exit)
	IniWrite($settings, "GuiText", "Edit", $Text_Edit)
	IniWrite($settings, "GuiText", "Cut", $Text_Cut)
	IniWrite($settings, "GuiText", "Copy", $Text_Copy)
	IniWrite($settings, "GuiText", "Paste", $Text_Paste)
	IniWrite($settings, "GuiText", "Delete", $Text_Delete)
	IniWrite($settings, "GuiText", "Select", $Text_Select)
	IniWrite($settings, "GuiText", "SelectAll", $Text_SelectAll)
	IniWrite($settings, "GuiText", "Options", $Text_Options)
	IniWrite($settings, "GuiText", "AutoSort", $Text_AutoSort)
	IniWrite($settings, "GuiText", "SortTree", $Text_SortTree)
	IniWrite($settings, "GuiText", "PlaySound", $Text_PlaySound)
	IniWrite($settings, "GuiText", "AddAPsToTop", $Text_AddAPsToTop)
	IniWrite($settings, "GuiText", "Extra", $Text_Extra)
	IniWrite($settings, "GuiText", "ScanAPs", $Text_ScanAPs)
	IniWrite($settings, "GuiText", "StopScanAps", $Text_StopScanAps)
	IniWrite($settings, "GuiText", "UseGPS", $Text_UseGPS)
	IniWrite($settings, "GuiText", "StopGPS", $Text_StopGPS)
	IniWrite($settings, "GuiText", "Settings", $Text_Settings)
	IniWrite($settings, "GuiText", "GpsSettings", $Text_GpsSettings)
	IniWrite($settings, "GuiText", "SetLanguage", $Text_SetLanguage)
	IniWrite($settings, "GuiText", "SetSearchWords", $Text_SetSearchWords)
	IniWrite($settings, "GuiText", "Export", $Text_Export)
	IniWrite($settings, "GuiText", "ExportToKML", $Text_ExportToKML)
	IniWrite($settings, "GuiText", "ExportToTXT", $Text_ExportToTXT)
	IniWrite($settings, "GuiText", "PhilsPHPgraph", $Text_PhilsPHPgraph)
	IniWrite($settings, "GuiText", "PhilsMultiPHPgraph", $Text_PhilsMultiPHPgraph)
	IniWrite($settings, "GuiText", "RefreshLoopTime", $Text_RefreshLoopTime)
	IniWrite($settings, "GuiText", "ActualLoopTime", $Text_ActualLoopTime)
	IniWrite($settings, "GuiText", "Longitude", $Text_Longitude)
	IniWrite($settings, "GuiText", "Latitude", $Text_Latitude)
	IniWrite($settings, "GuiText", "ActiveAPs", $Text_ActiveAPs)
	IniWrite($settings, "GuiText", "Graph1", $Text_Graph1)
	IniWrite($settings, "GuiText", "Graph2", $Text_Graph2)
	IniWrite($settings, "GuiText", "NoGraph", $Text_NoGraph)
	IniWrite($settings, 'GuiText', 'SetMacLabel', $Text_SetMacLabel)
	IniWrite($settings, 'GuiText', 'SetMacManu', $Text_SetMacManu)
	IniWrite($settings, 'GuiText', 'Active', $Text_Active)
	IniWrite($settings, 'GuiText', 'Dead', $Text_Dead)
	IniWrite($settings, 'GuiText', 'AddNewLabel', $Text_AddNewLabel)
	IniWrite($settings, 'GuiText', 'RemoveLabel', $Text_RemoveLabel)
	IniWrite($settings, 'GuiText', 'EditLabel', $Text_EditLabel)
	IniWrite($settings, 'GuiText', 'AddNewMan', $Text_AddNewMan)
	IniWrite($settings, 'GuiText', 'RemoveMan', $Text_RemoveMan)
	IniWrite($settings, 'GuiText', 'EditMan', $Text_EditMan)
	IniWrite($settings, 'GuiText', 'NewMac', $Text_NewMac)
	IniWrite($settings, 'GuiText', 'NewMan', $Text_NewMan)
	IniWrite($settings, 'GuiText', 'NewLabel', $Text_NewLabel)
	IniWrite($settings, 'GuiText', 'Save', $Text_Save)
	IniWrite($settings, 'GuiText', 'SaveQuestion', $Text_SaveQuestion)
	IniWrite($settings, 'GuiText', 'GpsDetails', $Text_GpsDetails)
	IniWrite($settings, 'GuiText', 'Quality', $Text_Quality)
	IniWrite($settings, 'GuiText', 'Time', $Text_Time)
	IniWrite($settings, 'GuiText', 'NumberOfSatalites', $Text_NumberOfSatalites)
	IniWrite($settings, 'GuiText', 'HorizontalDilutionPosition', $Text_HorizontalDilutionPosition)
	IniWrite($settings, 'GuiText', 'Altitude', $Text_Altitude)
	IniWrite($settings, 'GuiText', 'HeightOfGeoid', $Text_HeightOfGeoid)
	IniWrite($settings, 'GuiText', 'Status', $Text_Status)
	IniWrite($settings, 'GuiText', 'Date', $Text_Date)
	IniWrite($settings, 'GuiText', 'SpeedInKnots', $Text_SpeedInKnots)
	IniWrite($settings, 'GuiText', 'SpeedInMPH', $Text_SpeedInMPH)
	IniWrite($settings, 'GuiText', 'SpeedInKmh', $Text_SpeedInKmh)
	IniWrite($settings, 'GuiText', 'TrackAngle', $Text_TrackAngle)
	IniWrite($settings, 'GuiText', 'Close', $Text_Close)

EndFunc   ;==>_WriteINI

Func MyErrFunc()
	$ComError = 1
EndFunc   ;==>MyErrFunc

Func _SetDataArraySizes()
	$DataArray_Line[0] = UBound($DataArray_Active) - 1
	$DataArray_Active[0] = UBound($DataArray_Active) - 1
	$DataArray_BSSID[0] = UBound($DataArray_BSSID) - 1
	$DataArray_SSID[0] = UBound($DataArray_SSID) - 1
	$DataArray_Auth[0] = UBound($DataArray_Auth) - 1
	$DataArray_Encr[0] = UBound($DataArray_Encr) - 1
	$DataArray_Sig[0] = UBound($DataArray_Sig) - 1
	$DataArray_Chan[0] = UBound($DataArray_Chan) - 1
	$DataArray_Rad[0] = UBound($DataArray_Rad) - 1
	$DataArray_Lon[0] = UBound($DataArray_Lon) - 1
	$DataArray_Lat[0] = UBound($DataArray_Lat) - 1
	$DataArray_BtX[0] = UBound($DataArray_BtX) - 1
	$DataArray_OtX[0] = UBound($DataArray_OtX) - 1
	$DataArray_NetType[0] = UBound($DataArray_NetType) - 1
	$DataArray_FirstTime[0] = UBound($DataArray_FirstTime) - 1
	$DataArray_LastTime[0] = UBound($DataArray_LastTime) - 1
	$DataArray_SigHist[0] = UBound($DataArray_SigHist) - 1
	$DataArray_Manu[0] = UBound($DataArray_Manu) - 1
	$DataArray_Label[0] = UBound($DataArray_Label) - 1
	$DataArray_Row[0] = UBound($DataArray_Row) - 1
	$DataArray_TreeViewSubChannel[0] = UBound($DataArray_TreeViewSubChannel) - 1
	$DataArray_TreeViewSubSSID[0] = UBound($DataArray_TreeViewSubSSID) - 1
	$DataArray_TreeViewSubEncr[0] = UBound($DataArray_TreeViewSubEncr) - 1
	$DataArray_TreeViewSubAuth[0] = UBound($DataArray_TreeViewSubAuth) - 1
	$DataArray_TreeViewSubNetType[0] = UBound($DataArray_TreeViewSubNetType) - 1
EndFunc   ;==>_SetDataArraySizes

Func _SetTmpArraySizes()
	$TmpArray_BSSID[0] = UBound($TmpArray_BSSID) - 1
	$TmpArray_SSID[0] = UBound($TmpArray_SSID) - 1
	$TmpArray_Auth[0] = UBound($TmpArray_Auth) - 1
	$TmpArray_Encr[0] = UBound($TmpArray_Encr) - 1
	$TmpArray_Sig[0] = UBound($TmpArray_Sig) - 1
	$TmpArray_Chan[0] = UBound($TmpArray_Chan) - 1
	$TmpArray_Rad[0] = UBound($TmpArray_Rad) - 1
	$TmpArray_BtX[0] = UBound($TmpArray_BtX) - 1
	$TmpArray_OtX[0] = UBound($TmpArray_OtX) - 1
	$TmpArray_NetType[0] = UBound($TmpArray_NetType) - 1
	$TmpArray_Time[0] = UBound($TmpArray_Time) - 1
EndFunc   ;==>_SetTmpArraySizes

Func _SetTreeArraySizes()
	$TreeView_Channel_Name[0] = UBound($TreeView_Channel_Name) - 1
	$TreeView_SSID_Name[0] = UBound($TreeView_SSID_Name) - 1
	$TreeView_Encryption_Name[0] = UBound($TreeView_Encryption_Name) - 1
	$TreeView_Authentication_Name[0] = UBound($TreeView_Authentication_Name) - 1
	$TreeView_NetworkType_Name[0] = UBound($TreeView_NetworkType_Name) - 1
	$TreeView_Channel_Pos[0] = UBound($TreeView_Channel_Pos) - 1
	$TreeView_SSID_Pos[0] = UBound($TreeView_SSID_Pos) - 1
	$TreeView_Encryption_Pos[0] = UBound($TreeView_Encryption_Pos) - 1
	$TreeView_Authentication_Pos[0] = UBound($TreeView_Authentication_Pos) - 1
	$TreeView_NetworkType_Pos[0] = UBound($TreeView_NetworkType_Pos) - 1
	$TmpArray_Time[0] = UBound($TmpArray_Time) - 1
EndFunc   ;==>_SetTreeArraySizes

Dim $TreeView_Channel_Name[1]
Dim $TreeView_SSID_Name[1]
Dim $TreeView_Encryption_Name[1]
Dim $TreeView_Authentication_Name[1]
Dim $TreeView_NetworkType_Name[1]
Dim $TreeView_Channel_Pos[1]
Dim $TreeView_SSID_Pos[1]
Dim $TreeView_Encryption_Pos[1]
Dim $TreeView_Authentication_Pos[1]
Dim $TreeView_NetworkType_Pos[1]

Func _FixLineNumbers()
	;$foundline = 0
	$ListViewSize = _GUICtrlListView_GetItemCount ($ListviewAPs) - 1; Get List Size
	For $arrayrow = 1 To $DataArray_Line[0]
		For $lisviewrow = 0 To $ListViewSize
			If $DataArray_Line[$arrayrow] = _GUICtrlListView_GetItemText ($ListviewAPs, $lisviewrow, $column_Line) Then
				$DataArray_Row[$arrayrow] = $lisviewrow
				ExitLoop
			EndIf
		Next
	Next
EndFunc   ;==>_FixLineNumbers

Func _ReadIniSectionToArrays($ini, ByRef $ar1, ByRef $ar2, $section)
	$var = IniReadSection($ini, $section)
	If Not @error Then
		For $i = 1 To $var[0][0]
			_ArrayAdd($ar1, StringUpper($var[$i][0]))
			_ArrayAdd($ar2, $var[$i][1])
		Next
		$ar1[0] = UBound($ar2) - 1
		$ar2[0] = UBound($ar2) - 1
	EndIf
EndFunc   ;==>_ReadIniSectionToArrays

Func _MacLabelGUI()
	_MacListGUI($label_mac, $label_label, $Text_SetMacLabel, $Text_NewMac, $Text_NewLabel, $Text_AddNewLabel, $Text_RemoveLabel, $Text_EditLabel, "Edit Label", "Mac Address:", "Label:", 12, $labelsini, "LABELS")
EndFunc   ;==>_MacLabelGUI

Func _MacManuGUI()
	_MacListGUI($manu_mac, $manu_manu, $Text_SetMacManu, $Text_NewMac, $Text_NewMan, $Text_AddNewMan, $Text_RemoveMan, $Text_EditMan, "Edit Mac Manufacturer", "Mac Address:", "Manufacturer:", 6, $manufini, "MANUFACURERS")
EndFunc   ;==>_MacManuGUI

Func _MacListGUI(ByRef $GUI_mac, ByRef $GUI_GUI, $title, $Text_NM, $Text_MM, $Text_ANM, $Text_RM, $Text_EM, $editgui_title, $editgui_mac, $editgui_ml, $StringTrim, $ini, $section)
	Opt("GUIOnEventMode", 0)
	$GUI = GUICreate($title, 651, 530, -1, -1)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateLabel($Text_NM, 8, 16, 94, 17)
	$NewMacAddress = GUICtrlCreateInput("", 104, 16, 105, 21)
	GUICtrlCreateLabel($Text_MM, 224, 16, 100, 17)
	$NewGUI = GUICtrlCreateInput("", 330, 16, 315, 21)
	$AddGUI = GUICtrlCreateButton($Text_ANM, 8, 50, 200, 25, 0)
	$RemoveGUI = GUICtrlCreateButton($Text_RM, 225, 50, 205, 25, 0)
	$EditGUI = GUICtrlCreateButton($Text_EM, 444, 50, 200, 25, 0)
	$GUIList = GUICtrlCreateListView($Column_Names_BSSID & "|" & $Column_Names_MANUF, 8, 88, 633, 401, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
	GUICtrlSetBkColor(-1, $ControlBackgroundColor)
	_GUICtrlListView_SetColumnWidth ($GUIList, 0, 160)
	_GUICtrlListView_SetColumnWidth ($GUIList, 1, 450)
	$GuiOk = GUICtrlCreateButton($Text_Ok, 240, 495, 73, 25, 0)
	$GuiCancel = GUICtrlCreateButton($Text_Cancel, 323, 495, 73, 25, 0)
	
	;Copy Items from array into the listview
	For $m = 1 To $GUI_mac[0]
		$arraysearch = _GUICtrlListView_InsertItem ($GUIList, $AddDirection, '')
		_GUICtrlListView_SetItemText ($GUIList, $arraysearch, '"' & $GUI_mac[$m] & '"', 0)
		_GUICtrlListView_SetItemText ($GUIList, $arraysearch, $GUI_GUI[$m], 1)
	Next
	
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUIList
				_HeaderSort2(GUICtrlGetState($GUIList))
			Case $AddGUI
				$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(StringReplace(GUICtrlRead($NewMacAddress), ':', ''), '-', ''), '"', ''), ' ', ''))
				$AddMac = '"' & StringTrimRight($StrippedMac, StringLen($StrippedMac) - $StringTrim) & '"' 
				$AddLM = GUICtrlRead($NewGUI)
				$arraysearch = -1
				$itemcount = _GUICtrlListView_GetItemCount ($GUIList) - 1; Get List Size
				For $findloop = 0 To $itemcount; Find BSSID list; If found, set $arraysearch with position
					If _GUICtrlListView_GetItemText ($GUIList, $findloop, 0) = $AddMac Then
						$arraysearch = $findloop
						ExitLoop
					EndIf
				Next
				If $arraysearch = -1 Then
					$arraysearch = _GUICtrlListView_InsertItem ($GUIList, 0, '')
					_GUICtrlListView_SetItemText ($GUIList, $arraysearch, $AddMac, 0)
					_GUICtrlListView_SetItemText ($GUIList, $arraysearch, $AddLM, 1)
				Else
					$overwrite_entry = MsgBox(4, "Overwrite?", "A entry for this mac address already exists. would you like to overwrite it?")
					If $overwrite_entry = 6 Then
						_GUICtrlListView_SetItemText ($GUIList, $arraysearch, $AddMac, 0)
						_GUICtrlListView_SetItemText ($GUIList, $arraysearch, $AddLM, 1)
					EndIf
				EndIf
			Case $EditGUI
				$EditLine = _GUICtrlListView_GetNextItem ($GUIList)
				If $EditLine <> $LV_ERR Then
					$EditMac = StringTrimRight(StringTrimLeft(_GUICtrlListView_GetItemText ($GUIList, $EditLine, 0), 1), 1)
					$EditLab = _GUICtrlListView_GetItemText ($GUIList, $EditLine, 1)
					$EditMacGUIForm = GUICreate($editgui_title, 625, 86, -1, -1)
					GUISetBkColor($BackgroundColor)
					GUICtrlCreateLabel($editgui_mac, 16, 16, 69, 17)
					$EditMac_Mac = GUICtrlCreateInput($EditMac, 88, 16, 137, 21)
					GUICtrlCreateLabel($editgui_ml, 230, 16, 70, 17)
					$EditMac_GUI = GUICtrlCreateInput($EditLab, 305, 16, 300, 21)
					$EditMac_OK = GUICtrlCreateButton($Text_Ok, 200, 48, 97, 25, 0)
					$EditMac_Can = GUICtrlCreateButton($Text_Cancel, 312, 48, 97, 25, 0)
					GUISetState(@SW_SHOW)
					While 1
						$nMsg = GUIGetMsg()
						If $nMsg = $GUI_EVENT_CLOSE Then ExitLoop
						If $nMsg = $EditMac_Can Then ExitLoop
						If $nMsg = $EditMac_OK Then
							$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(StringReplace(GUICtrlRead($EditMac_Mac), ':', ''), '-', ''), '"', ''), ' ', ''))
							_GUICtrlListView_SetItemText ($GUIList, $EditLine, '"' & StringTrimRight($StrippedMac, StringLen($StrippedMac) - $StringTrim) & '"', 0)
							_GUICtrlListView_SetItemText ($GUIList, $EditLine, GUICtrlRead($EditMac_GUI), 1)
							ExitLoop
						EndIf
					WEnd
					GUIDelete($EditMacGUIForm)
				EndIf
			Case $RemoveGUI
				$EditLine = _GUICtrlListView_GetNextItem ($GUIList)
				If $EditLine <> $LV_ERR Then _GUICtrlListView_DeleteItem ($GUIList, $EditLine)
			Case $GuiOk
				SplashTextOn("Saving", "Saving... Please wait", 200, 50)

				;Remove all current Mac address/labels in the array
				Dim $GUI_mac[1]
				Dim $GUI_GUI[1]
				
				;Rewrite Mac address/labels from listview into the array
				$itemcount = _GUICtrlListView_GetItemCount ($GUIList) - 1; Get List Size
				For $findloop = 0 To $itemcount
					_ArrayAdd($GUI_mac, StringTrimLeft(StringTrimRight(_GUICtrlListView_GetItemText ($GUIList, $itemcount - $findloop, 0), 1), 1))
					_ArrayAdd($GUI_GUI, _GUICtrlListView_GetItemText ($GUIList, $itemcount - $findloop, 1))
				Next
				$GUI_mac[0] = UBound($GUI_mac) - 1
				$GUI_GUI[0] = UBound($GUI_GUI) - 1
				
				;rewrite manufacturer ini
				IniDelete($ini, $section)
				For $m = 1 To $GUI_mac[0]
					IniWrite($ini, $section, $GUI_mac[$m], $GUI_GUI[$m])
				Next
				
				;Set flag so lables get reset
				$ResetMacLabel = 1
				
				SplashOff()
				ExitLoop
			Case $GuiCancel
				ExitLoop
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($GUI)
EndFunc   ;==>_MacListGUI